<TeXmacs|1.0.6>

<style|generic>

<\body>
  <doc-data|<doc-title|Fast Algorithms for FMM Matrices>>

  An <dfn|FMM matrix> is row and column indexed by <dfn|hierarchical
  partition trees>. The column tree is also called the <dfn|input tree>,
  while the row tree is also called the <dfn|output tree>. There are two
  types of edges that lead from the input tree to the output tree. These are
  called <with|mode|math|B>-edges and <with|mode|math|D>-edges. The
  <with|mode|math|D>-edges transmit the input at that node to the
  corresponding output. The <with|mode|math|B>-edges transmit the input state
  at that node to the corresponing output state at the output node. The state
  at any node is broadcast on all output edges. The state at any node is the
  sum of all incoming edges. <with|mode|math|D>-edges must start and stop at
  leaf edges. <strong|Once there is a <with|mode|math|B>-edge between two
  nodes, there can be no further edges between their children.> This is
  essentially the only constraint on the set up. Other constraints can serve
  as <em|sufficient> conditions for the matrix to be invertible but it is not
  necessary.

  \ \ 
</body>

<\initial>
  <\collection>
    <associate|page-type|letter>
  </collection>
</initial>