/*
  File generated from blop_c.idl
  Original in blop_c_stubs.c
  Please be careful not to overwrite this file! it contains
  important changes. Use diff instead.

  $Id: blop_c_stubs_mod.c,v 1.3 2005/01/18 19:17:25 shiv Exp shiv $
*/

#include <stddef.h>
#include <string.h>
#include <caml/mlvalues.h>
#include <caml/memory.h>
#include <caml/alloc.h>
#include <caml/fail.h>
#include <caml/callback.h>
#ifdef Custom_tag
#include <caml/custom.h>
#include <caml/bigarray.h>
#endif
/* #include <caml/camlidlruntime.h> */


#include "blop_c.h"
#include <stdio.h>

value camlidl_blop_c_my_dlange(
	value _v_norm,
	value _v_m,
	value _v_n,
	value _v_a,
	value _v_disp,
	value _v_lda,
	value _v_work)
{
  int norm; /*in*/
  int m; /*in*/
  int n; /*in*/
  double *a; /*in,out*/
  int disp; /*in*/
  int lda; /*in*/
  double *work; /*in,out*/
  double _res;
  value _vres;

  norm = Int_val(_v_norm);
  m = Int_val(_v_m);
  n = Int_val(_v_n);
  a = Bigarray_val(_v_a)->data;
  disp = Int_val(_v_disp);
  lda = Int_val(_v_lda);
  work = Bigarray_val(_v_work)->data;
  enter_blocking_section ();
  _res = my_dlange(norm, m, n, a, disp, lda, work);
  leave_blocking_section ();
  _vres = copy_double(_res);
  return _vres;
}

value camlidl_blop_c_my_dlange_bytecode(value * argv, int argn)
{
  return camlidl_blop_c_my_dlange(argv[0], argv[1], argv[2], argv[3], argv[4], argv[5], argv[6]);
}

value camlidl_blop_c_my_slange(
	value _v_norm,
	value _v_m,
	value _v_n,
	value _v_a,
	value _v_disp,
	value _v_lda,
	value _v_work)
{
  int norm; /*in*/
  int m; /*in*/
  int n; /*in*/
  float *a; /*in,out*/
  int disp; /*in*/
  int lda; /*in*/
  float *work; /*in,out*/
  float _res;
  value _vres;

  norm = Int_val(_v_norm);
  m = Int_val(_v_m);
  n = Int_val(_v_n);
  a = Bigarray_val(_v_a)->data;
  disp = Int_val(_v_disp);
  lda = Int_val(_v_lda);
  work = Bigarray_val(_v_work)->data;
  enter_blocking_section ();
  _res = my_slange(norm, m, n, a, disp, lda, work);
  leave_blocking_section ();
  _vres = copy_double(_res);
  return _vres;
}

value camlidl_blop_c_my_slange_bytecode(value * argv, int argn)
{
  return camlidl_blop_c_my_slange(argv[0], argv[1], argv[2], argv[3], argv[4], argv[5], argv[6]);
}

value camlidl_blop_c_my_cblas_dgemm(
	value _v_order,
	value _v_transA,
	value _v_transB,
	value _v_m,
	value _v_n,
	value _v_k,
	value _v_alpha,
	value _v_a,
	value _v_dispa,
	value _v_lda,
	value _v_b,
	value _v_dispb,
	value _v_ldb,
	value _v_beta,
	value _v_c,
	value _v_dispc,
	value _v_ldc)
{
  int order; /*in*/
  int transA; /*in*/
  int transB; /*in*/
  int m; /*in*/
  int n; /*in*/
  int k; /*in*/
  double alpha; /*in*/
  double *a; /*in,out*/
  int dispa; /*in*/
  int lda; /*in*/
  double *b; /*in,out*/
  int dispb; /*in*/
  int ldb; /*in*/
  double beta; /*in*/
  double *c; /*in,out*/
  int dispc; /*in*/
  int ldc; /*in*/
  int _res;
  value _vres;

  order = Int_val(_v_order);
  transA = Int_val(_v_transA);
  transB = Int_val(_v_transB);
  m = Int_val(_v_m);
  n = Int_val(_v_n);
  k = Int_val(_v_k);
  alpha = Double_val(_v_alpha);
  a = Bigarray_val(_v_a)->data;
  dispa = Int_val(_v_dispa);
  lda = Int_val(_v_lda);
  b = Bigarray_val(_v_b)->data;
  dispb = Int_val(_v_dispb);
  ldb = Int_val(_v_ldb);
  beta = Double_val(_v_beta);
  c = Bigarray_val(_v_c)->data;
  dispc = Int_val(_v_dispc);
  ldc = Int_val(_v_ldc);
  enter_blocking_section ();
  _res = my_cblas_dgemm(order, transA, transB, m, n, k, alpha, a, dispa, lda, b, dispb, ldb, beta, c, dispc, ldc);
  leave_blocking_section ();
  _vres = Val_int(_res);
  return _vres;
}

value camlidl_blop_c_my_cblas_dgemm_bytecode(value * argv, int argn)
{
  return camlidl_blop_c_my_cblas_dgemm(argv[0], argv[1], argv[2], argv[3], argv[4], argv[5], argv[6], argv[7], argv[8], argv[9], argv[10], argv[11], argv[12], argv[13], argv[14], argv[15], argv[16]);
}

value camlidl_blop_c_my_cblas_sgemm(
	value _v_order,
	value _v_transA,
	value _v_transB,
	value _v_m,
	value _v_n,
	value _v_k,
	value _v_alpha,
	value _v_a,
	value _v_dispa,
	value _v_lda,
	value _v_b,
	value _v_dispb,
	value _v_ldb,
	value _v_beta,
	value _v_c,
	value _v_dispc,
	value _v_ldc)
{
  int order; /*in*/
  int transA; /*in*/
  int transB; /*in*/
  int m; /*in*/
  int n; /*in*/
  int k; /*in*/
  float alpha; /*in*/
  float *a; /*in,out*/
  int dispa; /*in*/
  int lda; /*in*/
  float *b; /*in,out*/
  int dispb; /*in*/
  int ldb; /*in*/
  float beta; /*in*/
  float *c; /*in,out*/
  int dispc; /*in*/
  int ldc; /*in*/
  int _res;
  value _vres;

  order = Int_val(_v_order);
  transA = Int_val(_v_transA);
  transB = Int_val(_v_transB);
  m = Int_val(_v_m);
  n = Int_val(_v_n);
  k = Int_val(_v_k);
  alpha = Double_val(_v_alpha);
  a = Bigarray_val(_v_a)->data;
  dispa = Int_val(_v_dispa);
  lda = Int_val(_v_lda);
  b = Bigarray_val(_v_b)->data;
  dispb = Int_val(_v_dispb);
  ldb = Int_val(_v_ldb);
  beta = Double_val(_v_beta);
  c = Bigarray_val(_v_c)->data;
  dispc = Int_val(_v_dispc);
  ldc = Int_val(_v_ldc);
  enter_blocking_section ();
  _res = my_cblas_sgemm(order, transA, transB, m, n, k, alpha, a, dispa, lda, b, dispb, ldb, beta, c, dispc, ldc);
  leave_blocking_section ();
  _vres = Val_int(_res);
  return _vres;
}

value camlidl_blop_c_my_cblas_sgemm_bytecode(value * argv, int argn)
{
  return camlidl_blop_c_my_cblas_sgemm(argv[0], argv[1], argv[2], argv[3], argv[4], argv[5], argv[6], argv[7], argv[8], argv[9], argv[10], argv[11], argv[12], argv[13], argv[14], argv[15], argv[16]);
}

value camlidl_blop_c_my_dgeqlf(
	value _v_m,
	value _v_n,
	value _v_a,
	value _v_dispa,
	value _v_lda,
	value _v_tau,
	value _v_work,
	value _v_lwork)
{
  int m; /*in*/
  int n; /*in*/
  double *a; /*in,out*/
  int dispa; /*in*/
  int lda; /*in*/
  double *tau; /*in,out*/
  double *work; /*in,out*/
  int lwork; /*in*/
  int _res;
  value _vres;

  m = Int_val(_v_m);
  n = Int_val(_v_n);
  a = Bigarray_val(_v_a)->data;
  dispa = Int_val(_v_dispa);
  lda = Int_val(_v_lda);
  tau = Bigarray_val(_v_tau)->data;
  work = Bigarray_val(_v_work)->data;
  lwork = Int_val(_v_lwork);
  enter_blocking_section ();
  _res = my_dgeqlf(m, n, a, dispa, lda, tau, work, lwork);
  leave_blocking_section ();
  _vres = Val_int(_res);
  return _vres;
}

value camlidl_blop_c_my_dgeqlf_bytecode(value * argv, int argn)
{
  return camlidl_blop_c_my_dgeqlf(argv[0], argv[1], argv[2], argv[3], argv[4], argv[5], argv[6], argv[7]);
}

value camlidl_blop_c_my_dgelqf(
	value _v_m,
	value _v_n,
	value _v_a,
	value _v_dispa,
	value _v_lda,
	value _v_tau,
	value _v_work,
	value _v_lwork)
{
  int m; /*in*/
  int n; /*in*/
  double *a; /*in,out*/
  int dispa; /*in*/
  int lda; /*in*/
  double *tau; /*in,out*/
  double *work; /*in,out*/
  int lwork; /*in*/
  int _res;
  value _vres;

  m = Int_val(_v_m);
  n = Int_val(_v_n);
  a = Bigarray_val(_v_a)->data;
  dispa = Int_val(_v_dispa);
  lda = Int_val(_v_lda);
  tau = Bigarray_val(_v_tau)->data;
  work = Bigarray_val(_v_work)->data;
  lwork = Int_val(_v_lwork);
  enter_blocking_section ();
  _res = my_dgelqf(m, n, a, dispa, lda, tau, work, lwork);
  leave_blocking_section ();
  _vres = Val_int(_res);
  return _vres;
}

value camlidl_blop_c_my_dgelqf_bytecode(value * argv, int argn)
{
  return camlidl_blop_c_my_dgelqf(argv[0], argv[1], argv[2], argv[3], argv[4], argv[5], argv[6], argv[7]);
}

value camlidl_blop_c_my_sgeqlf(
	value _v_m,
	value _v_n,
	value _v_a,
	value _v_dispa,
	value _v_lda,
	value _v_tau,
	value _v_work,
	value _v_lwork)
{
  int m; /*in*/
  int n; /*in*/
  float *a; /*in,out*/
  int dispa; /*in*/
  int lda; /*in*/
  float *tau; /*in,out*/
  float *work; /*in,out*/
  int lwork; /*in*/
  int _res;
  value _vres;

  m = Int_val(_v_m);
  n = Int_val(_v_n);
  a = Bigarray_val(_v_a)->data;
  dispa = Int_val(_v_dispa);
  lda = Int_val(_v_lda);
  tau = Bigarray_val(_v_tau)->data;
  work = Bigarray_val(_v_work)->data;
  lwork = Int_val(_v_lwork);
  enter_blocking_section ();
  _res = my_sgeqlf(m, n, a, dispa, lda, tau, work, lwork);
  leave_blocking_section ();
  _vres = Val_int(_res);
  return _vres;
}

value camlidl_blop_c_my_sgeqlf_bytecode(value * argv, int argn)
{
  return camlidl_blop_c_my_sgeqlf(argv[0], argv[1], argv[2], argv[3], argv[4], argv[5], argv[6], argv[7]);
}

value camlidl_blop_c_my_sgelqf(
	value _v_m,
	value _v_n,
	value _v_a,
	value _v_dispa,
	value _v_lda,
	value _v_tau,
	value _v_work,
	value _v_lwork)
{
  int m; /*in*/
  int n; /*in*/
  float *a; /*in,out*/
  int dispa; /*in*/
  int lda; /*in*/
  float *tau; /*in,out*/
  float *work; /*in,out*/
  int lwork; /*in*/
  int _res;
  value _vres;

  m = Int_val(_v_m);
  n = Int_val(_v_n);
  a = Bigarray_val(_v_a)->data;
  dispa = Int_val(_v_dispa);
  lda = Int_val(_v_lda);
  tau = Bigarray_val(_v_tau)->data;
  work = Bigarray_val(_v_work)->data;
  lwork = Int_val(_v_lwork);
  enter_blocking_section ();
  _res = my_sgelqf(m, n, a, dispa, lda, tau, work, lwork);
  leave_blocking_section ();
  _vres = Val_int(_res);
  return _vres;
}

value camlidl_blop_c_my_sgelqf_bytecode(value * argv, int argn)
{
  return camlidl_blop_c_my_sgelqf(argv[0], argv[1], argv[2], argv[3], argv[4], argv[5], argv[6], argv[7]);
}

value camlidl_blop_c_my_dormql(
	value _v_side,
	value _v_trans,
	value _v_m,
	value _v_n,
	value _v_k,
	value _v_a,
	value _v_dispa,
	value _v_lda,
	value _v_tau,
	value _v_c,
	value _v_dispc,
	value _v_ldc,
	value _v_work,
	value _v_lwork)
{
  int side; /*in*/
  int trans; /*in*/
  int m; /*in*/
  int n; /*in*/
  int k; /*in*/
  double *a; /*in,out*/
  int dispa; /*in*/
  int lda; /*in*/
  double *tau; /*in,out*/
  double *c; /*in,out*/
  int dispc; /*in*/
  int ldc; /*in*/
  double *work; /*in,out*/
  int lwork; /*in*/
  int _res;
  value _vres;

  side = Int_val(_v_side);
  trans = Int_val(_v_trans);
  m = Int_val(_v_m);
  n = Int_val(_v_n);
  k = Int_val(_v_k);
  a = Bigarray_val(_v_a)->data;
  dispa = Int_val(_v_dispa);
  lda = Int_val(_v_lda);
  tau = Bigarray_val(_v_tau)->data;
  c = Bigarray_val(_v_c)->data;
  dispc = Int_val(_v_dispc);
  ldc = Int_val(_v_ldc);
  work = Bigarray_val(_v_work)->data;
  lwork = Int_val(_v_lwork);
  enter_blocking_section ();
  _res = my_dormql(side, trans, m, n, k, a, dispa, lda, tau, c, dispc, ldc, work, lwork);
  leave_blocking_section ();
  _vres = Val_int(_res);
  return _vres;
}

value camlidl_blop_c_my_dormql_bytecode(value * argv, int argn)
{
  return camlidl_blop_c_my_dormql(argv[0], argv[1], argv[2], argv[3], argv[4], argv[5], argv[6], argv[7], argv[8], argv[9], argv[10], argv[11], argv[12], argv[13]);
}

value camlidl_blop_c_my_dormlq(
	value _v_side,
	value _v_trans,
	value _v_m,
	value _v_n,
	value _v_k,
	value _v_a,
	value _v_dispa,
	value _v_lda,
	value _v_tau,
	value _v_c,
	value _v_dispc,
	value _v_ldc,
	value _v_work,
	value _v_lwork)
{
  int side; /*in*/
  int trans; /*in*/
  int m; /*in*/
  int n; /*in*/
  int k; /*in*/
  double *a; /*in,out*/
  int dispa; /*in*/
  int lda; /*in*/
  double *tau; /*in,out*/
  double *c; /*in,out*/
  int dispc; /*in*/
  int ldc; /*in*/
  double *work; /*in,out*/
  int lwork; /*in*/
  int _res;
  value _vres;

  side = Int_val(_v_side);
  trans = Int_val(_v_trans);
  m = Int_val(_v_m);
  n = Int_val(_v_n);
  k = Int_val(_v_k);
  a = Bigarray_val(_v_a)->data;
  dispa = Int_val(_v_dispa);
  lda = Int_val(_v_lda);
  tau = Bigarray_val(_v_tau)->data;
  c = Bigarray_val(_v_c)->data;
  dispc = Int_val(_v_dispc);
  ldc = Int_val(_v_ldc);
  work = Bigarray_val(_v_work)->data;
  lwork = Int_val(_v_lwork);
  enter_blocking_section ();
  _res = my_dormlq(side, trans, m, n, k, a, dispa, lda, tau, c, dispc, ldc, work, lwork);
  leave_blocking_section ();
  _vres = Val_int(_res);
  return _vres;
}

value camlidl_blop_c_my_dormlq_bytecode(value * argv, int argn)
{
  return camlidl_blop_c_my_dormlq(argv[0], argv[1], argv[2], argv[3], argv[4], argv[5], argv[6], argv[7], argv[8], argv[9], argv[10], argv[11], argv[12], argv[13]);
}

value camlidl_blop_c_my_sormql(
	value _v_side,
	value _v_trans,
	value _v_m,
	value _v_n,
	value _v_k,
	value _v_a,
	value _v_dispa,
	value _v_lda,
	value _v_tau,
	value _v_c,
	value _v_dispc,
	value _v_ldc,
	value _v_work,
	value _v_lwork)
{
  int side; /*in*/
  int trans; /*in*/
  int m; /*in*/
  int n; /*in*/
  int k; /*in*/
  float *a; /*in,out*/
  int dispa; /*in*/
  int lda; /*in*/
  float *tau; /*in,out*/
  float *c; /*in,out*/
  int dispc; /*in*/
  int ldc; /*in*/
  float *work; /*in,out*/
  int lwork; /*in*/
  int _res;
  value _vres;

  side = Int_val(_v_side);
  trans = Int_val(_v_trans);
  m = Int_val(_v_m);
  n = Int_val(_v_n);
  k = Int_val(_v_k);
  a = Bigarray_val(_v_a)->data;
  dispa = Int_val(_v_dispa);
  lda = Int_val(_v_lda);
  tau = Bigarray_val(_v_tau)->data;
  c = Bigarray_val(_v_c)->data;
  dispc = Int_val(_v_dispc);
  ldc = Int_val(_v_ldc);
  work = Bigarray_val(_v_work)->data;
  lwork = Int_val(_v_lwork);
  enter_blocking_section ();
  _res = my_sormql(side, trans, m, n, k, a, dispa, lda, tau, c, dispc, ldc, work, lwork);
  leave_blocking_section ();
  _vres = Val_int(_res);
  return _vres;
}

value camlidl_blop_c_my_sormql_bytecode(value * argv, int argn)
{
  return camlidl_blop_c_my_sormql(argv[0], argv[1], argv[2], argv[3], argv[4], argv[5], argv[6], argv[7], argv[8], argv[9], argv[10], argv[11], argv[12], argv[13]);
}

value camlidl_blop_c_my_sormlq(
	value _v_side,
	value _v_trans,
	value _v_m,
	value _v_n,
	value _v_k,
	value _v_a,
	value _v_dispa,
	value _v_lda,
	value _v_tau,
	value _v_c,
	value _v_dispc,
	value _v_ldc,
	value _v_work,
	value _v_lwork)
{
  int side; /*in*/
  int trans; /*in*/
  int m; /*in*/
  int n; /*in*/
  int k; /*in*/
  float *a; /*in,out*/
  int dispa; /*in*/
  int lda; /*in*/
  float *tau; /*in,out*/
  float *c; /*in,out*/
  int dispc; /*in*/
  int ldc; /*in*/
  float *work; /*in,out*/
  int lwork; /*in*/
  int _res;
  value _vres;

  side = Int_val(_v_side);
  trans = Int_val(_v_trans);
  m = Int_val(_v_m);
  n = Int_val(_v_n);
  k = Int_val(_v_k);
  a = Bigarray_val(_v_a)->data;
  dispa = Int_val(_v_dispa);
  lda = Int_val(_v_lda);
  tau = Bigarray_val(_v_tau)->data;
  c = Bigarray_val(_v_c)->data;
  dispc = Int_val(_v_dispc);
  ldc = Int_val(_v_ldc);
  work = Bigarray_val(_v_work)->data;
  lwork = Int_val(_v_lwork);
  enter_blocking_section ();
  _res = my_sormlq(side, trans, m, n, k, a, dispa, lda, tau, c, dispc, ldc, work, lwork);
  leave_blocking_section ();
  _vres = Val_int(_res);
  return _vres;
}

value camlidl_blop_c_my_sormlq_bytecode(value * argv, int argn)
{
  return camlidl_blop_c_my_sormlq(argv[0], argv[1], argv[2], argv[3], argv[4], argv[5], argv[6], argv[7], argv[8], argv[9], argv[10], argv[11], argv[12], argv[13]);
}

value camlidl_blop_c_my_dlacpy(
	value _v_uplo,
	value _v_m,
	value _v_n,
	value _v_a,
	value _v_dispa,
	value _v_lda,
	value _v_b,
	value _v_dispb,
	value _v_ldb)
{
  int uplo; /*in*/
  int m; /*in*/
  int n; /*in*/
  double *a; /*in,out*/
  int dispa; /*in*/
  int lda; /*in*/
  double *b; /*in,out*/
  int dispb; /*in*/
  int ldb; /*in*/
  int _res;
  value _vres;

  uplo = Int_val(_v_uplo);
  m = Int_val(_v_m);
  n = Int_val(_v_n);
  a = Bigarray_val(_v_a)->data;
  dispa = Int_val(_v_dispa);
  lda = Int_val(_v_lda);
  b = Bigarray_val(_v_b)->data;
  dispb = Int_val(_v_dispb);
  ldb = Int_val(_v_ldb);
  enter_blocking_section ();
  _res = my_dlacpy(uplo, m, n, a, dispa, lda, b, dispb, ldb);
  leave_blocking_section ();
  _vres = Val_int(_res);
  return _vres;
}

value camlidl_blop_c_my_dlacpy_bytecode(value * argv, int argn)
{
  return camlidl_blop_c_my_dlacpy(argv[0], argv[1], argv[2], argv[3], argv[4], argv[5], argv[6], argv[7], argv[8]);
}

value camlidl_blop_c_my_slacpy(
	value _v_uplo,
	value _v_m,
	value _v_n,
	value _v_a,
	value _v_dispa,
	value _v_lda,
	value _v_b,
	value _v_dispb,
	value _v_ldb)
{
  int uplo; /*in*/
  int m; /*in*/
  int n; /*in*/
  float *a; /*in,out*/
  int dispa; /*in*/
  int lda; /*in*/
  float *b; /*in,out*/
  int dispb; /*in*/
  int ldb; /*in*/
  int _res;
  value _vres;

  uplo = Int_val(_v_uplo);
  m = Int_val(_v_m);
  n = Int_val(_v_n);
  a = Bigarray_val(_v_a)->data;
  dispa = Int_val(_v_dispa);
  lda = Int_val(_v_lda);
  b = Bigarray_val(_v_b)->data;
  dispb = Int_val(_v_dispb);
  ldb = Int_val(_v_ldb);
  enter_blocking_section ();
  _res = my_slacpy(uplo, m, n, a, dispa, lda, b, dispb, ldb);
  leave_blocking_section ();
  _vres = Val_int(_res);
  return _vres;
}

value camlidl_blop_c_my_slacpy_bytecode(value * argv, int argn)
{
  return camlidl_blop_c_my_slacpy(argv[0], argv[1], argv[2], argv[3], argv[4], argv[5], argv[6], argv[7], argv[8]);
}

value camlidl_blop_c_my_dsub(
	value _v_m,
	value _v_n,
	value _v_a,
	value _v_dispa,
	value _v_lda,
	value _v_b,
	value _v_dispb,
	value _v_ldb,
	value _v_c,
	value _v_dispc,
	value _v_ldc)
{
  int m; /*in*/
  int n; /*in*/
  double *a; /*in,out*/
  int dispa; /*in*/
  int lda; /*in*/
  double *b; /*in,out*/
  int dispb; /*in*/
  int ldb; /*in*/
  double *c; /*in,out*/
  int dispc; /*in*/
  int ldc; /*in*/
  int _res;
  value _vres;

  m = Int_val(_v_m);
  n = Int_val(_v_n);
  a = Bigarray_val(_v_a)->data;
  dispa = Int_val(_v_dispa);
  lda = Int_val(_v_lda);
  b = Bigarray_val(_v_b)->data;
  dispb = Int_val(_v_dispb);
  ldb = Int_val(_v_ldb);
  c = Bigarray_val(_v_c)->data;
  dispc = Int_val(_v_dispc);
  ldc = Int_val(_v_ldc);
  enter_blocking_section ();
  _res = my_dsub(m, n, a, dispa, lda, b, dispb, ldb, c, dispc, ldc);
  leave_blocking_section ();
  _vres = Val_int(_res);
  return _vres;
}

value camlidl_blop_c_my_dsub_bytecode(value * argv, int argn)
{
  return camlidl_blop_c_my_dsub(argv[0], argv[1], argv[2], argv[3], argv[4], argv[5], argv[6], argv[7], argv[8], argv[9], argv[10]);
}

value camlidl_blop_c_my_ssub(
	value _v_m,
	value _v_n,
	value _v_a,
	value _v_dispa,
	value _v_lda,
	value _v_b,
	value _v_dispb,
	value _v_ldb,
	value _v_c,
	value _v_dispc,
	value _v_ldc)
{
  int m; /*in*/
  int n; /*in*/
  float *a; /*in,out*/
  int dispa; /*in*/
  int lda; /*in*/
  float *b; /*in,out*/
  int dispb; /*in*/
  int ldb; /*in*/
  float *c; /*in,out*/
  int dispc; /*in*/
  int ldc; /*in*/
  int _res;
  value _vres;

  m = Int_val(_v_m);
  n = Int_val(_v_n);
  a = Bigarray_val(_v_a)->data;
  dispa = Int_val(_v_dispa);
  lda = Int_val(_v_lda);
  b = Bigarray_val(_v_b)->data;
  dispb = Int_val(_v_dispb);
  ldb = Int_val(_v_ldb);
  c = Bigarray_val(_v_c)->data;
  dispc = Int_val(_v_dispc);
  ldc = Int_val(_v_ldc);
  enter_blocking_section ();
  _res = my_ssub(m, n, a, dispa, lda, b, dispb, ldb, c, dispc, ldc);
  leave_blocking_section ();
  _vres = Val_int(_res);
  return _vres;
}

value camlidl_blop_c_my_ssub_bytecode(value * argv, int argn)
{
  return camlidl_blop_c_my_ssub(argv[0], argv[1], argv[2], argv[3], argv[4], argv[5], argv[6], argv[7], argv[8], argv[9], argv[10]);
}

value camlidl_blop_c_my_dgels(
	value _v_trans,
	value _v_m,
	value _v_n,
	value _v_nrhs,
	value _v_a,
	value _v_dispa,
	value _v_lda,
	value _v_b,
	value _v_dispb,
	value _v_ldb,
	value _v_work,
	value _v_lwork)
{
  int trans; /*in*/
  int m; /*in*/
  int n; /*in*/
  int nrhs; /*in*/
  double *a; /*in,out*/
  int dispa; /*in*/
  int lda; /*in*/
  double *b; /*in,out*/
  int dispb; /*in*/
  int ldb; /*in*/
  double *work; /*in,out*/
  int lwork; /*in*/
  int _res;
  value _vres;

  trans = Int_val(_v_trans);
  m = Int_val(_v_m);
  n = Int_val(_v_n);
  nrhs = Int_val(_v_nrhs);
  a = Bigarray_val(_v_a)->data;
  dispa = Int_val(_v_dispa);
  lda = Int_val(_v_lda);
  b = Bigarray_val(_v_b)->data;
  dispb = Int_val(_v_dispb);
  ldb = Int_val(_v_ldb);
  work = Bigarray_val(_v_work)->data;
  lwork = Int_val(_v_lwork);
  _res = my_dgels(trans, m, n, nrhs, a, dispa, lda, b, dispb, ldb, work, lwork);
  _vres = Val_int(_res);
  return _vres;
}

value camlidl_blop_c_my_dgels_bytecode(value * argv, int argn)
{
  return camlidl_blop_c_my_dgels(argv[0], argv[1], argv[2], argv[3], argv[4], argv[5], argv[6], argv[7], argv[8], argv[9], argv[10], argv[11]);
}


value camlidl_blop_c_my_sgels(
	value _v_trans,
	value _v_m,
	value _v_n,
	value _v_nrhs,
	value _v_a,
	value _v_dispa,
	value _v_lda,
	value _v_b,
	value _v_dispb,
	value _v_ldb,
	value _v_work,
	value _v_lwork)
{
  int trans; /*in*/
  int m; /*in*/
  int n; /*in*/
  int nrhs; /*in*/
  float *a; /*in,out*/
  int dispa; /*in*/
  int lda; /*in*/
  float *b; /*in,out*/
  int dispb; /*in*/
  int ldb; /*in*/
  float *work; /*in,out*/
  int lwork; /*in*/
  int _res;
  value _vres;

  trans = Int_val(_v_trans);
  m = Int_val(_v_m);
  n = Int_val(_v_n);
  nrhs = Int_val(_v_nrhs);
  a = Bigarray_val(_v_a)->data;
  dispa = Int_val(_v_dispa);
  lda = Int_val(_v_lda);
  b = Bigarray_val(_v_b)->data;
  dispb = Int_val(_v_dispb);
  ldb = Int_val(_v_ldb);
  work = Bigarray_val(_v_work)->data;
  lwork = Int_val(_v_lwork);
  enter_blocking_section ();
  _res = my_sgels(trans, m, n, nrhs, a, dispa, lda, b, dispb, ldb, work, lwork);
  enter_blocking_section ();
  _vres = Val_int(_res);
  return _vres;
}

value camlidl_blop_c_my_sgels_bytecode(value * argv, int argn)
{
  return camlidl_blop_c_my_sgels(argv[0], argv[1], argv[2], argv[3], argv[4], argv[5], argv[6], argv[7], argv[8], argv[9], argv[10], argv[11]);
}

value camlidl_blop_c_my_dtrtrs(
	value _v_uplo,
	value _v_trans,
	value _v_diag,
	value _v_n,
	value _v_nrhs,
	value _v_a,
	value _v_dispa,
	value _v_lda,
	value _v_b,
	value _v_dispb,
	value _v_ldb)
{
  int uplo; /*in*/
  int trans; /*in*/
  int diag; /*in*/
  int n; /*in*/
  int nrhs; /*in*/
  double *a; /*in,out*/
  int dispa; /*in*/
  int lda; /*in*/
  double *b; /*in,out*/
  int dispb; /*in*/
  int ldb; /*in*/
  int _res;
  value _vres;

  uplo = Int_val(_v_uplo);
  trans = Int_val(_v_trans);
  diag = Int_val(_v_diag);
  n = Int_val(_v_n);
  nrhs = Int_val(_v_nrhs);
  a = Bigarray_val(_v_a)->data;
  dispa = Int_val(_v_dispa);
  lda = Int_val(_v_lda);
  b = Bigarray_val(_v_b)->data;
  dispb = Int_val(_v_dispb);
  ldb = Int_val(_v_ldb);
  enter_blocking_section ();
  _res = my_dtrtrs(uplo, trans, diag, n, nrhs, a, dispa, lda, b, dispb, ldb);
  leave_blocking_section ();
  _vres = Val_int(_res);
  return _vres;
}

value camlidl_blop_c_my_dtrtrs_bytecode(value * argv, int argn)
{
  return camlidl_blop_c_my_dtrtrs(argv[0], argv[1], argv[2], argv[3], argv[4], argv[5], argv[6], argv[7], argv[8], argv[9], argv[10]);
}

value camlidl_blop_c_my_strtrs(
	value _v_uplo,
	value _v_trans,
	value _v_diag,
	value _v_n,
	value _v_nrhs,
	value _v_a,
	value _v_dispa,
	value _v_lda,
	value _v_b,
	value _v_dispb,
	value _v_ldb)
{
  int uplo; /*in*/
  int trans; /*in*/
  int diag; /*in*/
  int n; /*in*/
  int nrhs; /*in*/
  float *a; /*in,out*/
  int dispa; /*in*/
  int lda; /*in*/
  float *b; /*in,out*/
  int dispb; /*in*/
  int ldb; /*in*/
  int _res;
  value _vres;

  uplo = Int_val(_v_uplo);
  trans = Int_val(_v_trans);
  diag = Int_val(_v_diag);
  n = Int_val(_v_n);
  nrhs = Int_val(_v_nrhs);
  a = Bigarray_val(_v_a)->data;
  dispa = Int_val(_v_dispa);
  lda = Int_val(_v_lda);
  b = Bigarray_val(_v_b)->data;
  dispb = Int_val(_v_dispb);
  ldb = Int_val(_v_ldb);
  enter_blocking_section ();
  _res = my_strtrs(uplo, trans, diag, n, nrhs, a, dispa, lda, b, dispb, ldb);
  leave_blocking_section ();
  _vres = Val_int(_res);
  return _vres;
}

value camlidl_blop_c_my_strtrs_bytecode(value * argv, int argn)
{
  return camlidl_blop_c_my_strtrs(argv[0], argv[1], argv[2], argv[3], argv[4], argv[5], argv[6], argv[7], argv[8], argv[9], argv[10]);
}

value camlidl_blop_c_my_dgesvd(
	value _v_jobu,
	value _v_jobvt,
	value _v_m,
	value _v_n,
	value _v_a,
	value _v_dispa,
	value _v_lda,
	value _v_s,
	value _v_u,
	value _v_dispu,
	value _v_ldu,
	value _v_vt,
	value _v_dispvt,
	value _v_ldvt,
	value _v_work,
	value _v_lwork)
{
  int jobu; /*in*/
  int jobvt; /*in*/
  int m; /*in*/
  int n; /*in*/
  double *a; /*in,out*/
  int dispa; /*in*/
  int lda; /*in*/
  double *s; /*in,out*/
  double *u; /*in,out*/
  int dispu; /*in*/
  int ldu; /*in*/
  double *vt; /*in,out*/
  int dispvt; /*in*/
  int ldvt; /*in*/
  double *work; /*in,out*/
  int lwork; /*in*/
  int _res;
  value _vres;

  jobu = Int_val(_v_jobu);
  jobvt = Int_val(_v_jobvt);
  m = Int_val(_v_m);
  n = Int_val(_v_n);
  a = Bigarray_val(_v_a)->data;
  dispa = Int_val(_v_dispa);
  lda = Int_val(_v_lda);
  s = Bigarray_val(_v_s)->data;
  u = Bigarray_val(_v_u)->data;
  dispu = Int_val(_v_dispu);
  ldu = Int_val(_v_ldu);
  vt = Bigarray_val(_v_vt)->data;
  dispvt = Int_val(_v_dispvt);
  ldvt = Int_val(_v_ldvt);
  work = Bigarray_val(_v_work)->data;
  lwork = Int_val(_v_lwork);
  enter_blocking_section ();
  _res = my_dgesvd(jobu, jobvt, m, n, a, dispa, lda, s, u, dispu, ldu, vt, dispvt, ldvt, work, lwork);
  leave_blocking_section ();
  _vres = Val_int(_res);
  return _vres;
}

value camlidl_blop_c_my_dgesvd_bytecode(value * argv, int argn)
{
  return camlidl_blop_c_my_dgesvd(argv[0], argv[1], argv[2], argv[3], argv[4], argv[5], argv[6], argv[7], argv[8], argv[9], argv[10], argv[11], argv[12], argv[13], argv[14], argv[15]);
}

value camlidl_blop_c_my_sgesvd(
	value _v_jobu,
	value _v_jobvt,
	value _v_m,
	value _v_n,
	value _v_a,
	value _v_dispa,
	value _v_lda,
	value _v_s,
	value _v_u,
	value _v_dispu,
	value _v_ldu,
	value _v_vt,
	value _v_dispvt,
	value _v_ldvt,
	value _v_work,
	value _v_lwork)
{
  int jobu; /*in*/
  int jobvt; /*in*/
  int m; /*in*/
  int n; /*in*/
  float *a; /*in,out*/
  int dispa; /*in*/
  int lda; /*in*/
  float *s; /*in,out*/
  float *u; /*in,out*/
  int dispu; /*in*/
  int ldu; /*in*/
  float *vt; /*in,out*/
  int dispvt; /*in*/
  int ldvt; /*in*/
  float *work; /*in,out*/
  int lwork; /*in*/
  int _res;
  value _vres;

  jobu = Int_val(_v_jobu);
  jobvt = Int_val(_v_jobvt);
  m = Int_val(_v_m);
  n = Int_val(_v_n);
  a = Bigarray_val(_v_a)->data;
  dispa = Int_val(_v_dispa);
  lda = Int_val(_v_lda);
  s = Bigarray_val(_v_s)->data;
  u = Bigarray_val(_v_u)->data;
  dispu = Int_val(_v_dispu);
  ldu = Int_val(_v_ldu);
  vt = Bigarray_val(_v_vt)->data;
  dispvt = Int_val(_v_dispvt);
  ldvt = Int_val(_v_ldvt);
  work = Bigarray_val(_v_work)->data;
  lwork = Int_val(_v_lwork);
  enter_blocking_section ();
  _res = my_sgesvd(jobu, jobvt, m, n, a, dispa, lda, s, u, dispu, ldu, vt, dispvt, ldvt, work, lwork);
  leave_blocking_section ();
  _vres = Val_int(_res);
  return _vres;
}

value camlidl_blop_c_my_sgesvd_bytecode(value * argv, int argn)
{
  return camlidl_blop_c_my_sgesvd(argv[0], argv[1], argv[2], argv[3], argv[4], argv[5], argv[6], argv[7], argv[8], argv[9], argv[10], argv[11], argv[12], argv[13], argv[14], argv[15]);
}



/*
  This section conatins the complex routines which camlidl cannot
  handle. It was created from the precious section.
*/

value camlidl_blop_c_my_zlange(
	value _v_norm,
	value _v_m,
	value _v_n,
	value _v_a,
	value _v_disp,
	value _v_lda,
	value _v_work)
{
  int norm; /*in*/
  int m; /*in*/
  int n; /*in*/
  complex *a; /*in,out*/
  int disp; /*in*/
  int lda; /*in*/
  double *work; /*in,out*/
  double _res;
  value _vres;

  norm = Int_val(_v_norm);
  m = Int_val(_v_m);
  n = Int_val(_v_n);
  a = Bigarray_val(_v_a)->data;
  disp = Int_val(_v_disp);
  lda = Int_val(_v_lda);
  work = Bigarray_val(_v_work)->data;
  enter_blocking_section ();
  _res = my_zlange(norm, m, n, a, disp, lda, work);
  leave_blocking_section ();
  _vres = copy_double(_res);
  return _vres;
}

value camlidl_blop_c_my_zlange_bytecode(value * argv, int argn)
{
  return camlidl_blop_c_my_zlange(argv[0], argv[1], argv[2], argv[3], argv[4], argv[5], argv[6]);
}

value camlidl_blop_c_my_clange(
	value _v_norm,
	value _v_m,
	value _v_n,
	value _v_a,
	value _v_disp,
	value _v_lda,
	value _v_work)
{
  int norm; /*in*/
  int m; /*in*/
  int n; /*in*/
  scomplex *a; /*in,out*/
  int disp; /*in*/
  int lda; /*in*/
  float *work; /*in,out*/
  float _res;
  value _vres;

  norm = Int_val(_v_norm);
  m = Int_val(_v_m);
  n = Int_val(_v_n);
  a = Bigarray_val(_v_a)->data;
  disp = Int_val(_v_disp);
  lda = Int_val(_v_lda);
  work = Bigarray_val(_v_work)->data;
  enter_blocking_section ();
  _res = my_clange(norm, m, n, a, disp, lda, work);
  leave_blocking_section ();
  _vres = copy_double(_res);
  return _vres;
}

value camlidl_blop_c_my_clange_bytecode(value * argv, int argn)
{
  return camlidl_blop_c_my_clange(argv[0], argv[1], argv[2], argv[3], argv[4], argv[5], argv[6]);
}

void camlidl_ml2c_blop_c_complex(value _v1, complex * _c2)
{
  (*_c2).re = Double_field(_v1, 0);
  (*_c2).im = Double_field(_v1, 1);
}

void camlidl_ml2c_blop_c_scomplex(value _v1, scomplex * _c2)
{
  (*_c2).re = Double_field(_v1, 0);
  (*_c2).im = Double_field(_v1, 1);
}

value camlidl_blop_c_my_cblas_zgemm(
	value _v_order,
	value _v_transA,
	value _v_transB,
	value _v_m,
	value _v_n,
	value _v_k,
	value _v_alpha,
	value _v_a,
	value _v_dispa,
	value _v_lda,
	value _v_b,
	value _v_dispb,
	value _v_ldb,
	value _v_beta,
	value _v_c,
	value _v_dispc,
	value _v_ldc)
{
  int order; /*in*/
  int transA; /*in*/
  int transB; /*in*/
  int m; /*in*/
  int n; /*in*/
  int k; /*in*/
  complex alpha; /*in*/
  complex *a; /*in,out*/
  int dispa; /*in*/
  int lda; /*in*/
  complex *b; /*in,out*/
  int dispb; /*in*/
  int ldb; /*in*/
  complex beta; /*in*/
  complex *c; /*in,out*/
  int dispc; /*in*/
  int ldc; /*in*/
  int _res;
  value _vres;

  order = Int_val(_v_order);
  transA = Int_val(_v_transA);
  transB = Int_val(_v_transB);
  m = Int_val(_v_m);
  n = Int_val(_v_n);
  k = Int_val(_v_k);
  camlidl_ml2c_blop_c_complex(_v_alpha, &alpha);
  a = Bigarray_val(_v_a)->data;
  dispa = Int_val(_v_dispa);
  lda = Int_val(_v_lda);
  b = Bigarray_val(_v_b)->data;
  dispb = Int_val(_v_dispb);
  ldb = Int_val(_v_ldb);
  camlidl_ml2c_blop_c_complex(_v_beta, &beta);
  c = Bigarray_val(_v_c)->data;
  dispc = Int_val(_v_dispc);
  ldc = Int_val(_v_ldc);
  enter_blocking_section ();
  _res = my_cblas_zgemm(order, transA, transB, m, n, k, &alpha, a, dispa, lda, b, dispb, ldb, &beta, c, dispc, ldc);
  leave_blocking_section ();
  _vres = Val_int(_res);
  return _vres;
}

value camlidl_blop_c_my_cblas_zgemm_bytecode(value * argv, int argn)
{
  return camlidl_blop_c_my_cblas_zgemm(argv[0], argv[1], argv[2], argv[3], argv[4], argv[5], argv[6], argv[7], argv[8], argv[9], argv[10], argv[11], argv[12], argv[13], argv[14], argv[15], argv[16]);
}

value camlidl_blop_c_my_cblas_cgemm(
	value _v_order,
	value _v_transA,
	value _v_transB,
	value _v_m,
	value _v_n,
	value _v_k,
	value _v_alpha,
	value _v_a,
	value _v_dispa,
	value _v_lda,
	value _v_b,
	value _v_dispb,
	value _v_ldb,
	value _v_beta,
	value _v_c,
	value _v_dispc,
	value _v_ldc)
{
  int order; /*in*/
  int transA; /*in*/
  int transB; /*in*/
  int m; /*in*/
  int n; /*in*/
  int k; /*in*/
  scomplex alpha; /*in*/
  scomplex *a; /*in,out*/
  int dispa; /*in*/
  int lda; /*in*/
  scomplex *b; /*in,out*/
  int dispb; /*in*/
  int ldb; /*in*/
  scomplex beta; /*in*/
  scomplex *c; /*in,out*/
  int dispc; /*in*/
  int ldc; /*in*/
  int _res;
  value _vres;

  order = Int_val(_v_order);
  transA = Int_val(_v_transA);
  transB = Int_val(_v_transB);
  m = Int_val(_v_m);
  n = Int_val(_v_n);
  k = Int_val(_v_k);
  camlidl_ml2c_blop_c_scomplex(_v_alpha, &alpha);
  a = Bigarray_val(_v_a)->data;
  dispa = Int_val(_v_dispa);
  lda = Int_val(_v_lda);
  b = Bigarray_val(_v_b)->data;
  dispb = Int_val(_v_dispb);
  ldb = Int_val(_v_ldb);
  camlidl_ml2c_blop_c_scomplex(_v_beta, &beta);
  c = Bigarray_val(_v_c)->data;
  dispc = Int_val(_v_dispc);
  ldc = Int_val(_v_ldc);
  enter_blocking_section ();
  _res = my_cblas_cgemm(order, transA, transB, m, n, k, &alpha, a, dispa, lda, b, dispb, ldb, &beta, c, dispc, ldc);
  leave_blocking_section ();
  _vres = Val_int(_res);
  return _vres;
}

value camlidl_blop_c_my_cblas_cgemm_bytecode(value * argv, int argn)
{
  return camlidl_blop_c_my_cblas_cgemm(argv[0], argv[1], argv[2], argv[3], argv[4], argv[5], argv[6], argv[7], argv[8], argv[9], argv[10], argv[11], argv[12], argv[13], argv[14], argv[15], argv[16]);
}


value camlidl_blop_c_my_zgeqlf(
	value _v_m,
	value _v_n,
	value _v_a,
	value _v_dispa,
	value _v_lda,
	value _v_tau,
	value _v_work,
	value _v_lwork)
{
  int m; /*in*/
  int n; /*in*/
  complex *a; /*in,out*/
  int dispa; /*in*/
  int lda; /*in*/
  complex *tau; /*in,out*/
  complex *work; /*in,out*/
  int lwork; /*in*/
  int _res;
  value _vres;

  m = Int_val(_v_m);
  n = Int_val(_v_n);
  a = Bigarray_val(_v_a)->data;
  dispa = Int_val(_v_dispa);
  lda = Int_val(_v_lda);
  tau = Bigarray_val(_v_tau)->data;
  work = Bigarray_val(_v_work)->data;
  lwork = Int_val(_v_lwork);
  enter_blocking_section ();
  _res = my_zgeqlf(m, n, a, dispa, lda, tau, work, lwork);
  leave_blocking_section ();
  _vres = Val_int(_res);
  return _vres;
}

value camlidl_blop_c_my_zgeqlf_bytecode(value * argv, int argn)
{
  return camlidl_blop_c_my_zgeqlf(argv[0], argv[1], argv[2], argv[3], argv[4], argv[5], argv[6], argv[7]);
}


value camlidl_blop_c_my_zgelqf(
	value _v_m,
	value _v_n,
	value _v_a,
	value _v_dispa,
	value _v_lda,
	value _v_tau,
	value _v_work,
	value _v_lwork)
{
  int m; /*in*/
  int n; /*in*/
  complex *a; /*in,out*/
  int dispa; /*in*/
  int lda; /*in*/
  complex *tau; /*in,out*/
  complex *work; /*in,out*/
  int lwork; /*in*/
  int _res;
  value _vres;

  m = Int_val(_v_m);
  n = Int_val(_v_n);
  a = Bigarray_val(_v_a)->data;
  dispa = Int_val(_v_dispa);
  lda = Int_val(_v_lda);
  tau = Bigarray_val(_v_tau)->data;
  work = Bigarray_val(_v_work)->data;
  lwork = Int_val(_v_lwork);
  enter_blocking_section ();
  _res = my_zgelqf(m, n, a, dispa, lda, tau, work, lwork);
  leave_blocking_section ();
  _vres = Val_int(_res);
  return _vres;
}

value camlidl_blop_c_my_zgelqf_bytecode(value * argv, int argn)
{
  return camlidl_blop_c_my_zgelqf(argv[0], argv[1], argv[2], argv[3], argv[4], argv[5], argv[6], argv[7]);
}

value camlidl_blop_c_my_cgeqlf(
	value _v_m,
	value _v_n,
	value _v_a,
	value _v_dispa,
	value _v_lda,
	value _v_tau,
	value _v_work,
	value _v_lwork)
{
  int m; /*in*/
  int n; /*in*/
  scomplex *a; /*in,out*/
  int dispa; /*in*/
  int lda; /*in*/
  scomplex *tau; /*in,out*/
  scomplex *work; /*in,out*/
  int lwork; /*in*/
  int _res;
  value _vres;

  m = Int_val(_v_m);
  n = Int_val(_v_n);
  a = Bigarray_val(_v_a)->data;
  dispa = Int_val(_v_dispa);
  lda = Int_val(_v_lda);
  tau = Bigarray_val(_v_tau)->data;
  work = Bigarray_val(_v_work)->data;
  lwork = Int_val(_v_lwork);
  enter_blocking_section ();
  _res = my_cgeqlf(m, n, a, dispa, lda, tau, work, lwork);
  leave_blocking_section ();
  _vres = Val_int(_res);
  return _vres;
}

value camlidl_blop_c_my_cgeqlf_bytecode(value * argv, int argn)
{
  return camlidl_blop_c_my_cgeqlf(argv[0], argv[1], argv[2], argv[3], argv[4], argv[5], argv[6], argv[7]);
}

value camlidl_blop_c_my_cgelqf(
	value _v_m,
	value _v_n,
	value _v_a,
	value _v_dispa,
	value _v_lda,
	value _v_tau,
	value _v_work,
	value _v_lwork)
{
  int m; /*in*/
  int n; /*in*/
  scomplex *a; /*in,out*/
  int dispa; /*in*/
  int lda; /*in*/
  scomplex *tau; /*in,out*/
  scomplex *work; /*in,out*/
  int lwork; /*in*/
  int _res;
  value _vres;

  m = Int_val(_v_m);
  n = Int_val(_v_n);
  a = Bigarray_val(_v_a)->data;
  dispa = Int_val(_v_dispa);
  lda = Int_val(_v_lda);
  tau = Bigarray_val(_v_tau)->data;
  work = Bigarray_val(_v_work)->data;
  lwork = Int_val(_v_lwork);
  enter_blocking_section ();
  _res = my_cgelqf(m, n, a, dispa, lda, tau, work, lwork);
  leave_blocking_section ();
  _vres = Val_int(_res);
  return _vres;
}

value camlidl_blop_c_my_cgelqf_bytecode(value * argv, int argn)
{
  return camlidl_blop_c_my_cgelqf(argv[0], argv[1], argv[2], argv[3], argv[4], argv[5], argv[6], argv[7]);
}

value camlidl_blop_c_my_zunmql(
	value _v_side,
	value _v_trans,
	value _v_m,
	value _v_n,
	value _v_k,
	value _v_a,
	value _v_dispa,
	value _v_lda,
	value _v_tau,
	value _v_c,
	value _v_dispc,
	value _v_ldc,
	value _v_work,
	value _v_lwork)
{
  int side; /*in*/
  int trans; /*in*/
  int m; /*in*/
  int n; /*in*/
  int k; /*in*/
  complex *a; /*in,out*/
  int dispa; /*in*/
  int lda; /*in*/
  complex *tau; /*in,out*/
  complex *c; /*in,out*/
  int dispc; /*in*/
  int ldc; /*in*/
  complex *work; /*in,out*/
  int lwork; /*in*/
  int _res;
  value _vres;

  side = Int_val(_v_side);
  trans = Int_val(_v_trans);
  m = Int_val(_v_m);
  n = Int_val(_v_n);
  k = Int_val(_v_k);
  a = Bigarray_val(_v_a)->data;
  dispa = Int_val(_v_dispa);
  lda = Int_val(_v_lda);
  tau = Bigarray_val(_v_tau)->data;
  c = Bigarray_val(_v_c)->data;
  dispc = Int_val(_v_dispc);
  ldc = Int_val(_v_ldc);
  work = Bigarray_val(_v_work)->data;
  lwork = Int_val(_v_lwork);
  enter_blocking_section ();
  _res = my_zunmql(side, trans, m, n, k, a, dispa, lda, tau, c, dispc, ldc, work, lwork);
  leave_blocking_section ();
  _vres = Val_int(_res);
  return _vres;
}

value camlidl_blop_c_my_zunmql_bytecode(value * argv, int argn)
{
  return camlidl_blop_c_my_zunmql(argv[0], argv[1], argv[2], argv[3], argv[4], argv[5], argv[6], argv[7], argv[8], argv[9], argv[10], argv[11], argv[12], argv[13]);
}

value camlidl_blop_c_my_cunmql(
	value _v_side,
	value _v_trans,
	value _v_m,
	value _v_n,
	value _v_k,
	value _v_a,
	value _v_dispa,
	value _v_lda,
	value _v_tau,
	value _v_c,
	value _v_dispc,
	value _v_ldc,
	value _v_work,
	value _v_lwork)
{
  int side; /*in*/
  int trans; /*in*/
  int m; /*in*/
  int n; /*in*/
  int k; /*in*/
  scomplex *a; /*in,out*/
  int dispa; /*in*/
  int lda; /*in*/
  scomplex *tau; /*in,out*/
  scomplex *c; /*in,out*/
  int dispc; /*in*/
  int ldc; /*in*/
  scomplex *work; /*in,out*/
  int lwork; /*in*/
  int _res;
  value _vres;

  side = Int_val(_v_side);
  trans = Int_val(_v_trans);
  m = Int_val(_v_m);
  n = Int_val(_v_n);
  k = Int_val(_v_k);
  a = Bigarray_val(_v_a)->data;
  dispa = Int_val(_v_dispa);
  lda = Int_val(_v_lda);
  tau = Bigarray_val(_v_tau)->data;
  c = Bigarray_val(_v_c)->data;
  dispc = Int_val(_v_dispc);
  ldc = Int_val(_v_ldc);
  work = Bigarray_val(_v_work)->data;
  lwork = Int_val(_v_lwork);
  enter_blocking_section ();
  _res = my_cunmql(side, trans, m, n, k, a, dispa, lda, tau, c, dispc, ldc, work, lwork);
  leave_blocking_section ();
  _vres = Val_int(_res);
  return _vres;
}

value camlidl_blop_c_my_cunmql_bytecode(value * argv, int argn)
{
  return camlidl_blop_c_my_cunmql(argv[0], argv[1], argv[2], argv[3], argv[4], argv[5], argv[6], argv[7], argv[8], argv[9], argv[10], argv[11], argv[12], argv[13]);
}

value camlidl_blop_c_my_zunmlq(
	value _v_side,
	value _v_trans,
	value _v_m,
	value _v_n,
	value _v_k,
	value _v_a,
	value _v_dispa,
	value _v_lda,
	value _v_tau,
	value _v_c,
	value _v_dispc,
	value _v_ldc,
	value _v_work,
	value _v_lwork)
{
  int side; /*in*/
  int trans; /*in*/
  int m; /*in*/
  int n; /*in*/
  int k; /*in*/
  complex *a; /*in,out*/
  int dispa; /*in*/
  int lda; /*in*/
  complex *tau; /*in,out*/
  complex *c; /*in,out*/
  int dispc; /*in*/
  int ldc; /*in*/
  complex *work; /*in,out*/
  int lwork; /*in*/
  int _res;
  value _vres;

  side = Int_val(_v_side);
  trans = Int_val(_v_trans);
  m = Int_val(_v_m);
  n = Int_val(_v_n);
  k = Int_val(_v_k);
  a = Bigarray_val(_v_a)->data;
  dispa = Int_val(_v_dispa);
  lda = Int_val(_v_lda);
  tau = Bigarray_val(_v_tau)->data;
  c = Bigarray_val(_v_c)->data;
  dispc = Int_val(_v_dispc);
  ldc = Int_val(_v_ldc);
  work = Bigarray_val(_v_work)->data;
  lwork = Int_val(_v_lwork);
  enter_blocking_section ();
  _res = my_zunmlq(side, trans, m, n, k, a, dispa, lda, tau, c, dispc, ldc, work, lwork);
  leave_blocking_section ();
  _vres = Val_int(_res);
  return _vres;
}

value camlidl_blop_c_my_zunmlq_bytecode(value * argv, int argn)
{
  return camlidl_blop_c_my_zunmlq(argv[0], argv[1], argv[2], argv[3], argv[4], argv[5], argv[6], argv[7], argv[8], argv[9], argv[10], argv[11], argv[12], argv[13]);
}

value camlidl_blop_c_my_cunmlq(
	value _v_side,
	value _v_trans,
	value _v_m,
	value _v_n,
	value _v_k,
	value _v_a,
	value _v_dispa,
	value _v_lda,
	value _v_tau,
	value _v_c,
	value _v_dispc,
	value _v_ldc,
	value _v_work,
	value _v_lwork)
{
  int side; /*in*/
  int trans; /*in*/
  int m; /*in*/
  int n; /*in*/
  int k; /*in*/
  scomplex *a; /*in,out*/
  int dispa; /*in*/
  int lda; /*in*/
  scomplex *tau; /*in,out*/
  scomplex *c; /*in,out*/
  int dispc; /*in*/
  int ldc; /*in*/
  scomplex *work; /*in,out*/
  int lwork; /*in*/
  int _res;
  value _vres;

  side = Int_val(_v_side);
  trans = Int_val(_v_trans);
  m = Int_val(_v_m);
  n = Int_val(_v_n);
  k = Int_val(_v_k);
  a = Bigarray_val(_v_a)->data;
  dispa = Int_val(_v_dispa);
  lda = Int_val(_v_lda);
  tau = Bigarray_val(_v_tau)->data;
  c = Bigarray_val(_v_c)->data;
  dispc = Int_val(_v_dispc);
  ldc = Int_val(_v_ldc);
  work = Bigarray_val(_v_work)->data;
  lwork = Int_val(_v_lwork);
  enter_blocking_section ();
  _res = my_cunmlq(side, trans, m, n, k, a, dispa, lda, tau, c, dispc, ldc, work, lwork);
  leave_blocking_section ();
  _vres = Val_int(_res);
  return _vres;
}

value camlidl_blop_c_my_cunmlq_bytecode(value * argv, int argn)
{
  return camlidl_blop_c_my_cunmlq(argv[0], argv[1], argv[2], argv[3], argv[4], argv[5], argv[6], argv[7], argv[8], argv[9], argv[10], argv[11], argv[12], argv[13]);
}

value camlidl_blop_c_my_zlacpy(
	value _v_uplo,
	value _v_m,
	value _v_n,
	value _v_a,
	value _v_dispa,
	value _v_lda,
	value _v_b,
	value _v_dispb,
	value _v_ldb)
{
  int uplo; /*in*/
  int m; /*in*/
  int n; /*in*/
  complex *a; /*in,out*/
  int dispa; /*in*/
  int lda; /*in*/
  complex *b; /*in,out*/
  int dispb; /*in*/
  int ldb; /*in*/
  int _res;
  value _vres;

  uplo = Int_val(_v_uplo);
  m = Int_val(_v_m);
  n = Int_val(_v_n);
  a = Bigarray_val(_v_a)->data;
  dispa = Int_val(_v_dispa);
  lda = Int_val(_v_lda);
  b = Bigarray_val(_v_b)->data;
  dispb = Int_val(_v_dispb);
  ldb = Int_val(_v_ldb);
  enter_blocking_section ();
  _res = my_zlacpy(uplo, m, n, a, dispa, lda, b, dispb, ldb);
  leave_blocking_section ();
  _vres = Val_int(_res);
  return _vres;
}

value camlidl_blop_c_my_zlacpy_bytecode(value * argv, int argn)
{
  return camlidl_blop_c_my_zlacpy(argv[0], argv[1], argv[2], argv[3], argv[4], argv[5], argv[6], argv[7], argv[8]);
}

value camlidl_blop_c_my_clacpy(
	value _v_uplo,
	value _v_m,
	value _v_n,
	value _v_a,
	value _v_dispa,
	value _v_lda,
	value _v_b,
	value _v_dispb,
	value _v_ldb)
{
  int uplo; /*in*/
  int m; /*in*/
  int n; /*in*/
  scomplex *a; /*in,out*/
  int dispa; /*in*/
  int lda; /*in*/
  scomplex *b; /*in,out*/
  int dispb; /*in*/
  int ldb; /*in*/
  int _res;
  value _vres;

  uplo = Int_val(_v_uplo);
  m = Int_val(_v_m);
  n = Int_val(_v_n);
  a = Bigarray_val(_v_a)->data;
  dispa = Int_val(_v_dispa);
  lda = Int_val(_v_lda);
  b = Bigarray_val(_v_b)->data;
  dispb = Int_val(_v_dispb);
  ldb = Int_val(_v_ldb);
  enter_blocking_section ();
  _res = my_clacpy(uplo, m, n, a, dispa, lda, b, dispb, ldb);
  leave_blocking_section ();
  _vres = Val_int(_res);
  return _vres;
}

value camlidl_blop_c_my_clacpy_bytecode(value * argv, int argn)
{
  return camlidl_blop_c_my_clacpy(argv[0], argv[1], argv[2], argv[3], argv[4], argv[5], argv[6], argv[7], argv[8]);
}

value camlidl_blop_c_my_zgels(
	value _v_trans,
	value _v_m,
	value _v_n,
	value _v_nrhs,
	value _v_a,
	value _v_dispa,
	value _v_lda,
	value _v_b,
	value _v_dispb,
	value _v_ldb,
	value _v_work,
	value _v_lwork)
{
  int trans; /*in*/
  int m; /*in*/
  int n; /*in*/
  int nrhs; /*in*/
  complex *a; /*in,out*/
  int dispa; /*in*/
  int lda; /*in*/
  complex *b; /*in,out*/
  int dispb; /*in*/
  int ldb; /*in*/
  complex *work; /*in,out*/
  int lwork; /*in*/
  int _res;
  value _vres;

  trans = Int_val(_v_trans);
  m = Int_val(_v_m);
  n = Int_val(_v_n);
  nrhs = Int_val(_v_nrhs);
  a = Bigarray_val(_v_a)->data;
  dispa = Int_val(_v_dispa);
  lda = Int_val(_v_lda);
  b = Bigarray_val(_v_b)->data;
  dispb = Int_val(_v_dispb);
  ldb = Int_val(_v_ldb);
  work = Bigarray_val(_v_work)->data;
  lwork = Int_val(_v_lwork);
  _res = my_zgels(trans, m, n, nrhs, a, dispa, lda, b, dispb, ldb, work, lwork);
  _vres = Val_int(_res);
  return _vres;
}

value camlidl_blop_c_my_zgels_bytecode(value * argv, int argn)
{
  return camlidl_blop_c_my_zgels(argv[0], argv[1], argv[2], argv[3], argv[4], argv[5], argv[6], argv[7], argv[8], argv[9], argv[10], argv[11]);
}

value camlidl_blop_c_my_cgels(
	value _v_trans,
	value _v_m,
	value _v_n,
	value _v_nrhs,
	value _v_a,
	value _v_dispa,
	value _v_lda,
	value _v_b,
	value _v_dispb,
	value _v_ldb,
	value _v_work,
	value _v_lwork)
{
  int trans; /*in*/
  int m; /*in*/
  int n; /*in*/
  int nrhs; /*in*/
  scomplex *a; /*in,out*/
  int dispa; /*in*/
  int lda; /*in*/
  scomplex *b; /*in,out*/
  int dispb; /*in*/
  int ldb; /*in*/
  scomplex *work; /*in,out*/
  int lwork; /*in*/
  int _res;
  value _vres;

  trans = Int_val(_v_trans);
  m = Int_val(_v_m);
  n = Int_val(_v_n);
  nrhs = Int_val(_v_nrhs);
  a = Bigarray_val(_v_a)->data;
  dispa = Int_val(_v_dispa);
  lda = Int_val(_v_lda);
  b = Bigarray_val(_v_b)->data;
  dispb = Int_val(_v_dispb);
  ldb = Int_val(_v_ldb);
  work = Bigarray_val(_v_work)->data;
  lwork = Int_val(_v_lwork);
  _res = my_cgels(trans, m, n, nrhs, a, dispa, lda, b, dispb, ldb, work, lwork);
  _vres = Val_int(_res);
  return _vres;
}

value camlidl_blop_c_my_cgels_bytecode(value * argv, int argn)
{
  return camlidl_blop_c_my_cgels(argv[0], argv[1], argv[2], argv[3], argv[4], argv[5], argv[6], argv[7], argv[8], argv[9], argv[10], argv[11]);
}


value camlidl_blop_c_my_ztrtrs(
	value _v_uplo,
	value _v_trans,
	value _v_diag,
	value _v_n,
	value _v_nrhs,
	value _v_a,
	value _v_dispa,
	value _v_lda,
	value _v_b,
	value _v_dispb,
	value _v_ldb)
{
  int uplo; /*in*/
  int trans; /*in*/
  int diag; /*in*/
  int n; /*in*/
  int nrhs; /*in*/
  complex *a; /*in,out*/
  int dispa; /*in*/
  int lda; /*in*/
  complex *b; /*in,out*/
  int dispb; /*in*/
  int ldb; /*in*/
  int _res;
  value _vres;

  uplo = Int_val(_v_uplo);
  trans = Int_val(_v_trans);
  diag = Int_val(_v_diag);
  n = Int_val(_v_n);
  nrhs = Int_val(_v_nrhs);
  a = Bigarray_val(_v_a)->data;
  dispa = Int_val(_v_dispa);
  lda = Int_val(_v_lda);
  b = Bigarray_val(_v_b)->data;
  dispb = Int_val(_v_dispb);
  ldb = Int_val(_v_ldb);
  enter_blocking_section ();
  _res = my_ztrtrs(uplo, trans, diag, n, nrhs, a, dispa, lda, b, dispb, ldb);
  leave_blocking_section ();
  _vres = Val_int(_res);
  return _vres;
}

value camlidl_blop_c_my_ztrtrs_bytecode(value * argv, int argn)
{
  return camlidl_blop_c_my_ztrtrs(argv[0], argv[1], argv[2], argv[3], argv[4], argv[5], argv[6], argv[7], argv[8], argv[9], argv[10]);
}

value camlidl_blop_c_my_ctrtrs(
	value _v_uplo,
	value _v_trans,
	value _v_diag,
	value _v_n,
	value _v_nrhs,
	value _v_a,
	value _v_dispa,
	value _v_lda,
	value _v_b,
	value _v_dispb,
	value _v_ldb)
{
  int uplo; /*in*/
  int trans; /*in*/
  int diag; /*in*/
  int n; /*in*/
  int nrhs; /*in*/
  scomplex *a; /*in,out*/
  int dispa; /*in*/
  int lda; /*in*/
  scomplex *b; /*in,out*/
  int dispb; /*in*/
  int ldb; /*in*/
  int _res;
  value _vres;

  uplo = Int_val(_v_uplo);
  trans = Int_val(_v_trans);
  diag = Int_val(_v_diag);
  n = Int_val(_v_n);
  nrhs = Int_val(_v_nrhs);
  a = Bigarray_val(_v_a)->data;
  dispa = Int_val(_v_dispa);
  lda = Int_val(_v_lda);
  b = Bigarray_val(_v_b)->data;
  dispb = Int_val(_v_dispb);
  ldb = Int_val(_v_ldb);
  enter_blocking_section ();
  _res = my_ctrtrs(uplo, trans, diag, n, nrhs, a, dispa, lda, b, dispb, ldb);
  leave_blocking_section ();
  _vres = Val_int(_res);
  return _vres;
}

value camlidl_blop_c_my_ctrtrs_bytecode(value * argv, int argn)
{
  return camlidl_blop_c_my_ctrtrs(argv[0], argv[1], argv[2], argv[3], argv[4], argv[5], argv[6], argv[7], argv[8], argv[9], argv[10]);
}

value camlidl_blop_c_my_zgesvd(
	value _v_jobu,
	value _v_jobvt,
	value _v_m,
	value _v_n,
	value _v_a,
	value _v_dispa,
	value _v_lda,
	value _v_s,
	value _v_u,
	value _v_dispu,
	value _v_ldu,
	value _v_vt,
	value _v_dispvt,
	value _v_ldvt,
	value _v_work,
	value _v_lwork,
	value _v_rwork)
{
  int jobu; /*in*/
  int jobvt; /*in*/
  int m; /*in*/
  int n; /*in*/
  complex *a; /*in,out*/
  int dispa; /*in*/
  int lda; /*in*/
  double *s; /*in,out*/
  complex *u; /*in,out*/
  int dispu; /*in*/
  int ldu; /*in*/
  complex *vt; /*in,out*/
  int dispvt; /*in*/
  int ldvt; /*in*/
  complex *work; /*in,out*/
  int lwork; /*in*/
  double *rwork; /*in,out*/
  int _res;
  value _vres;

  jobu = Int_val(_v_jobu);
  jobvt = Int_val(_v_jobvt);
  m = Int_val(_v_m);
  n = Int_val(_v_n);
  a = Bigarray_val(_v_a)->data;
  dispa = Int_val(_v_dispa);
  lda = Int_val(_v_lda);
  s = Bigarray_val(_v_s)->data;
  u = Bigarray_val(_v_u)->data;
  dispu = Int_val(_v_dispu);
  ldu = Int_val(_v_ldu);
  vt = Bigarray_val(_v_vt)->data;
  dispvt = Int_val(_v_dispvt);
  ldvt = Int_val(_v_ldvt);
  work = Bigarray_val(_v_work)->data;
  lwork = Int_val(_v_lwork);
  rwork = Bigarray_val(_v_rwork)->data;
  enter_blocking_section ();
  _res = my_zgesvd(jobu, jobvt, m, n, a, dispa, lda, s, u, dispu, ldu, vt, dispvt, ldvt, work, lwork, rwork);
  leave_blocking_section ();
  _vres = Val_int(_res);
  return _vres;
}

value camlidl_blop_c_my_zgesvd_bytecode(value * argv, int argn)
{
  return camlidl_blop_c_my_zgesvd(argv[0], argv[1], argv[2], argv[3], argv[4], argv[5], argv[6], argv[7], argv[8], argv[9], argv[10], argv[11], argv[12], argv[13], argv[14], argv[15], argv[16]);
}

value camlidl_blop_c_my_cgesvd(
	value _v_jobu,
	value _v_jobvt,
	value _v_m,
	value _v_n,
	value _v_a,
	value _v_dispa,
	value _v_lda,
	value _v_s,
	value _v_u,
	value _v_dispu,
	value _v_ldu,
	value _v_vt,
	value _v_dispvt,
	value _v_ldvt,
	value _v_work,
	value _v_lwork,
	value _v_rwork)
{
  int jobu; /*in*/
  int jobvt; /*in*/
  int m; /*in*/
  int n; /*in*/
  scomplex *a; /*in,out*/
  int dispa; /*in*/
  int lda; /*in*/
  float *s; /*in,out*/
  scomplex *u; /*in,out*/
  int dispu; /*in*/
  int ldu; /*in*/
  scomplex *vt; /*in,out*/
  int dispvt; /*in*/
  int ldvt; /*in*/
  scomplex *work; /*in,out*/
  int lwork; /*in*/
  float *rwork; /*in,out*/
  int _res;
  value _vres;

  jobu = Int_val(_v_jobu);
  jobvt = Int_val(_v_jobvt);
  m = Int_val(_v_m);
  n = Int_val(_v_n);
  a = Bigarray_val(_v_a)->data;
  dispa = Int_val(_v_dispa);
  lda = Int_val(_v_lda);
  s = Bigarray_val(_v_s)->data;
  u = Bigarray_val(_v_u)->data;
  dispu = Int_val(_v_dispu);
  ldu = Int_val(_v_ldu);
  vt = Bigarray_val(_v_vt)->data;
  dispvt = Int_val(_v_dispvt);
  ldvt = Int_val(_v_ldvt);
  work = Bigarray_val(_v_work)->data;
  lwork = Int_val(_v_lwork);
  rwork = Bigarray_val(_v_rwork)->data;
  enter_blocking_section ();
  _res = my_cgesvd(jobu, jobvt, m, n, a, dispa, lda, s, u, dispu, ldu, vt, dispvt, ldvt, work, lwork, rwork);
  leave_blocking_section ();
  _vres = Val_int(_res);
  return _vres;
}

value camlidl_blop_c_my_cgesvd_bytecode(value * argv, int argn)
{
  return camlidl_blop_c_my_cgesvd(argv[0], argv[1], argv[2], argv[3], argv[4], argv[5], argv[6], argv[7], argv[8], argv[9], argv[10], argv[11], argv[12], argv[13], argv[14], argv[15], argv[16]);
}

value camlidl_blop_c_my_cblas_sswap(
	value _v_N,
	value _v_X,
	value _v_dispX,
	value _v_incX,
	value _v_Y,
	value _v_dispY,
	value _v_incY)
{
  int N; /*in*/
  float *X; /*in,out*/
  int dispX; /*in*/
  int incX; /*in*/
  float *Y; /*in,out*/
  int dispY; /*in*/
  int incY; /*in*/
  int _res;
  value _vres;

  N = Int_val(_v_N);
  X = Bigarray_val(_v_X)->data;
  dispX = Int_val(_v_dispX);
  incX = Int_val(_v_incX);
  Y = Bigarray_val(_v_Y)->data;
  dispY = Int_val(_v_dispY);
  incY = Int_val(_v_incY);
  _res = my_cblas_sswap(N, X, dispX, incX, Y, dispY, incY);
  _vres = Val_int(_res);
  return _vres;
}

value camlidl_blop_c_my_cblas_sswap_bytecode(value * argv, int argn)
{
  return camlidl_blop_c_my_cblas_sswap(argv[0], argv[1], argv[2], argv[3], argv[4], argv[5], argv[6]);
}

value camlidl_blop_c_my_cblas_dswap(
	value _v_N,
	value _v_X,
	value _v_dispX,
	value _v_incX,
	value _v_Y,
	value _v_dispY,
	value _v_incY)
{
  int N; /*in*/
  double *X; /*in,out*/
  int dispX; /*in*/
  int incX; /*in*/
  double *Y; /*in,out*/
  int dispY; /*in*/
  int incY; /*in*/
  int _res;
  value _vres;

  N = Int_val(_v_N);
  X = Bigarray_val(_v_X)->data;
  dispX = Int_val(_v_dispX);
  incX = Int_val(_v_incX);
  Y = Bigarray_val(_v_Y)->data;
  dispY = Int_val(_v_dispY);
  incY = Int_val(_v_incY);
  _res = my_cblas_dswap(N, X, dispX, incX, Y, dispY, incY);
  _vres = Val_int(_res);
  return _vres;
}

value camlidl_blop_c_my_cblas_dswap_bytecode(value * argv, int argn)
{
  return camlidl_blop_c_my_cblas_dswap(argv[0], argv[1], argv[2], argv[3], argv[4], argv[5], argv[6]);
}

value camlidl_blop_c_my_cblas_zswap(
	value _v_N,
	value _v_X,
	value _v_dispX,
	value _v_incX,
	value _v_Y,
	value _v_dispY,
	value _v_incY)
{
  int N; /*in*/
  complex *X; /*in,out*/
  int dispX; /*in*/
  int incX; /*in*/
  complex *Y; /*in,out*/
  int dispY; /*in*/
  int incY; /*in*/
  int _res;
  value _vres;

  N = Int_val(_v_N);
  X = Bigarray_val(_v_X)->data;
  dispX = Int_val(_v_dispX);
  incX = Int_val(_v_incX);
  Y = Bigarray_val(_v_Y)->data;
  dispY = Int_val(_v_dispY);
  incY = Int_val(_v_incY);
  _res = my_cblas_zswap(N, X, dispX, incX, Y, dispY, incY);
  _vres = Val_int(_res);
  return _vres;
}

value camlidl_blop_c_my_cblas_zswap_bytecode(value * argv, int argn)
{
  return camlidl_blop_c_my_cblas_zswap(argv[0], argv[1], argv[2], argv[3], argv[4], argv[5], argv[6]);
}

value camlidl_blop_c_my_cblas_cswap(
	value _v_N,
	value _v_X,
	value _v_dispX,
	value _v_incX,
	value _v_Y,
	value _v_dispY,
	value _v_incY)
{
  int N; /*in*/
  scomplex *X; /*in,out*/
  int dispX; /*in*/
  int incX; /*in*/
  scomplex *Y; /*in,out*/
  int dispY; /*in*/
  int incY; /*in*/
  int _res;
  value _vres;

  N = Int_val(_v_N);
  X = Bigarray_val(_v_X)->data;
  dispX = Int_val(_v_dispX);
  incX = Int_val(_v_incX);
  Y = Bigarray_val(_v_Y)->data;
  dispY = Int_val(_v_dispY);
  incY = Int_val(_v_incY);
  _res = my_cblas_cswap(N, X, dispX, incX, Y, dispY, incY);
  _vres = Val_int(_res);
  return _vres;
}

value camlidl_blop_c_my_cblas_cswap_bytecode(value * argv, int argn)
{
  return camlidl_blop_c_my_cblas_cswap(argv[0], argv[1], argv[2], argv[3], argv[4], argv[5], argv[6]);
}


value camlidl_blop_c_my_dgetrf(
	value _v_m,
	value _v_n,
	value _v_a,
	value _v_dispa,
	value _v_lda,
	value _v_ipiv)
{
  int m; /*in*/
  int n; /*in*/
  double *a; /*in,out*/
  int dispa; /*in*/
  int lda; /*in*/
  long int *ipiv; /*in,out*/
  int _res;
  value _vres;
  int i;

  m = Int_val(_v_m);
  n = Int_val(_v_n);
  a = Bigarray_val(_v_a)->data;
  dispa = Int_val(_v_dispa);
  lda = Int_val(_v_lda);
  ipiv = Bigarray_val(_v_ipiv)->data;
  _res = my_dgetrf(m, n, a, dispa, lda, ipiv);
  _vres = Val_int(_res);
  return _vres;
}

value camlidl_blop_c_my_dgetrf_bytecode(value * argv, int argn)
{
  return camlidl_blop_c_my_dgetrf(argv[0], argv[1], argv[2], argv[3], argv[4], argv[5]);
}

value camlidl_blop_c_my_sgetrf(
	value _v_m,
	value _v_n,
	value _v_a,
	value _v_dispa,
	value _v_lda,
	value _v_ipiv)
{
  int m; /*in*/
  int n; /*in*/
  float *a; /*in,out*/
  int dispa; /*in*/
  int lda; /*in*/
  long int *ipiv; /*in,out*/
  int _res;
  value _vres;

  m = Int_val(_v_m);
  n = Int_val(_v_n);
  a = Bigarray_val(_v_a)->data;
  dispa = Int_val(_v_dispa);
  lda = Int_val(_v_lda);
  ipiv = Bigarray_val(_v_ipiv)->data;
  _res = my_sgetrf(m, n, a, dispa, lda, ipiv);
  _vres = Val_int(_res);
  return _vres;
}

value camlidl_blop_c_my_sgetrf_bytecode(value * argv, int argn)
{
  return camlidl_blop_c_my_sgetrf(argv[0], argv[1], argv[2], argv[3], argv[4], argv[5]);
}

value camlidl_blop_c_my_zgetrf(
	value _v_m,
	value _v_n,
	value _v_a,
	value _v_dispa,
	value _v_lda,
	value _v_ipiv)
{
  int m; /*in*/
  int n; /*in*/
  complex *a; /*in,out*/
  int dispa; /*in*/
  int lda; /*in*/
  long int *ipiv; /*in,out*/
  int _res;
  value _vres;

  m = Int_val(_v_m);
  n = Int_val(_v_n);
  a = Bigarray_val(_v_a)->data;
  dispa = Int_val(_v_dispa);
  lda = Int_val(_v_lda);
  ipiv = Bigarray_val(_v_ipiv)->data;
  _res = my_zgetrf(m, n, a, dispa, lda, ipiv);
  _vres = Val_int(_res);
  return _vres;
}

value camlidl_blop_c_my_zgetrf_bytecode(value * argv, int argn)
{
  return camlidl_blop_c_my_zgetrf(argv[0], argv[1], argv[2], argv[3], argv[4], argv[5]);
}

value camlidl_blop_c_my_cgetrf(
	value _v_m,
	value _v_n,
	value _v_a,
	value _v_dispa,
	value _v_lda,
	value _v_ipiv)
{
  int m; /*in*/
  int n; /*in*/
  scomplex *a; /*in,out*/
  int dispa; /*in*/
  int lda; /*in*/
  long int *ipiv; /*in,out*/
  int _res;
  value _vres;

  m = Int_val(_v_m);
  n = Int_val(_v_n);
  a = Bigarray_val(_v_a)->data;
  dispa = Int_val(_v_dispa);
  lda = Int_val(_v_lda);
  ipiv = Bigarray_val(_v_ipiv)->data;
  _res = my_cgetrf(m, n, a, dispa, lda, ipiv);
  _vres = Val_int(_res);
  return _vres;
}

value camlidl_blop_c_my_cgetrf_bytecode(value * argv, int argn)
{
  return camlidl_blop_c_my_cgetrf(argv[0], argv[1], argv[2], argv[3], argv[4], argv[5]);
}

value camlidl_blop_c_my_dgeqrf(
	value _v_m,
	value _v_n,
	value _v_a,
	value _v_dispa,
	value _v_lda,
	value _v_tau,
	value _v_work,
	value _v_lwork)
{
  int m; /*in*/
  int n; /*in*/
  double *a; /*in,out*/
  int dispa; /*in*/
  int lda; /*in*/
  double *tau; /*in,out*/
  double *work; /*in,out*/
  int lwork; /*in*/
  int _res;
  value _vres;

  m = Int_val(_v_m);
  n = Int_val(_v_n);
  a = Bigarray_val(_v_a)->data;
  dispa = Int_val(_v_dispa);
  lda = Int_val(_v_lda);
  tau = Bigarray_val(_v_tau)->data;
  work = Bigarray_val(_v_work)->data;
  lwork = Int_val(_v_lwork);
  _res = my_dgeqrf(m, n, a, dispa, lda, tau, work, lwork);
  _vres = Val_int(_res);
  return _vres;
}

value camlidl_blop_c_my_dgeqrf_bytecode(value * argv, int argn)
{
  return camlidl_blop_c_my_dgeqrf(argv[0], argv[1], argv[2], argv[3], argv[4], argv[5], argv[6], argv[7]);
}

value camlidl_blop_c_my_sgeqrf(
	value _v_m,
	value _v_n,
	value _v_a,
	value _v_dispa,
	value _v_lda,
	value _v_tau,
	value _v_work,
	value _v_lwork)
{
  int m; /*in*/
  int n; /*in*/
  float *a; /*in,out*/
  int dispa; /*in*/
  int lda; /*in*/
  float *tau; /*in,out*/
  float *work; /*in,out*/
  int lwork; /*in*/
  int _res;
  value _vres;

  m = Int_val(_v_m);
  n = Int_val(_v_n);
  a = Bigarray_val(_v_a)->data;
  dispa = Int_val(_v_dispa);
  lda = Int_val(_v_lda);
  tau = Bigarray_val(_v_tau)->data;
  work = Bigarray_val(_v_work)->data;
  lwork = Int_val(_v_lwork);
  _res = my_sgeqrf(m, n, a, dispa, lda, tau, work, lwork);
  _vres = Val_int(_res);
  return _vres;
}

value camlidl_blop_c_my_sgeqrf_bytecode(value * argv, int argn)
{
  return camlidl_blop_c_my_sgeqrf(argv[0], argv[1], argv[2], argv[3], argv[4], argv[5], argv[6], argv[7]);
}

value camlidl_blop_c_my_zgeqrf(
	value _v_m,
	value _v_n,
	value _v_a,
	value _v_dispa,
	value _v_lda,
	value _v_tau,
	value _v_work,
	value _v_lwork)
{
  int m; /*in*/
  int n; /*in*/
  complex *a; /*in,out*/
  int dispa; /*in*/
  int lda; /*in*/
  complex *tau; /*in,out*/
  complex *work; /*in,out*/
  int lwork; /*in*/
  int _res;
  value _vres;

  m = Int_val(_v_m);
  n = Int_val(_v_n);
  a = Bigarray_val(_v_a)->data;
  dispa = Int_val(_v_dispa);
  lda = Int_val(_v_lda);
  tau = Bigarray_val(_v_tau)->data;
  work = Bigarray_val(_v_work)->data;
  lwork = Int_val(_v_lwork);
  _res = my_zgeqrf(m, n, a, dispa, lda, tau, work, lwork);
  _vres = Val_int(_res);
  return _vres;
}

value camlidl_blop_c_my_zgeqrf_bytecode(value * argv, int argn)
{
  return camlidl_blop_c_my_zgeqrf(argv[0], argv[1], argv[2], argv[3], argv[4], argv[5], argv[6], argv[7]);
}

value camlidl_blop_c_my_cgeqrf(
	value _v_m,
	value _v_n,
	value _v_a,
	value _v_dispa,
	value _v_lda,
	value _v_tau,
	value _v_work,
	value _v_lwork)
{
  int m; /*in*/
  int n; /*in*/
  scomplex *a; /*in,out*/
  int dispa; /*in*/
  int lda; /*in*/
  scomplex *tau; /*in,out*/
  scomplex *work; /*in,out*/
  int lwork; /*in*/
  int _res;
  value _vres;

  m = Int_val(_v_m);
  n = Int_val(_v_n);
  a = Bigarray_val(_v_a)->data;
  dispa = Int_val(_v_dispa);
  lda = Int_val(_v_lda);
  tau = Bigarray_val(_v_tau)->data;
  work = Bigarray_val(_v_work)->data;
  lwork = Int_val(_v_lwork);
  _res = my_cgeqrf(m, n, a, dispa, lda, tau, work, lwork);
  _vres = Val_int(_res);
  return _vres;
}

value camlidl_blop_c_my_cgeqrf_bytecode(value * argv, int argn)
{
  return camlidl_blop_c_my_cgeqrf(argv[0], argv[1], argv[2], argv[3], argv[4], argv[5], argv[6], argv[7]);
}


value camlidl_blop_c_my_dormqr(
	value _v_side,
	value _v_trans,
	value _v_m,
	value _v_n,
	value _v_k,
	value _v_a,
	value _v_dispa,
	value _v_lda,
	value _v_tau,
	value _v_c,
	value _v_dispc,
	value _v_ldc,
	value _v_work,
	value _v_lwork)
{
  int side; /*in*/
  int trans; /*in*/
  int m; /*in*/
  int n; /*in*/
  int k; /*in*/
  double *a; /*in,out*/
  int dispa; /*in*/
  int lda; /*in*/
  double *tau; /*in,out*/
  double *c; /*in,out*/
  int dispc; /*in*/
  int ldc; /*in*/
  double *work; /*in,out*/
  int lwork; /*in*/
  int _res;
  value _vres;

  side = Int_val(_v_side);
  trans = Int_val(_v_trans);
  m = Int_val(_v_m);
  n = Int_val(_v_n);
  k = Int_val(_v_k);
  a = Bigarray_val(_v_a)->data;
  dispa = Int_val(_v_dispa);
  lda = Int_val(_v_lda);
  tau = Bigarray_val(_v_tau)->data;
  c = Bigarray_val(_v_c)->data;
  dispc = Int_val(_v_dispc);
  ldc = Int_val(_v_ldc);
  work = Bigarray_val(_v_work)->data;
  lwork = Int_val(_v_lwork);
  _res = my_dormqr(side, trans, m, n, k, a, dispa, lda, tau, c, dispc, ldc, work, lwork);
  _vres = Val_int(_res);
  return _vres;
}

value camlidl_blop_c_my_dormqr_bytecode(value * argv, int argn)
{
  return camlidl_blop_c_my_dormqr(argv[0], argv[1], argv[2], argv[3], argv[4], argv[5], argv[6], argv[7], argv[8], argv[9], argv[10], argv[11], argv[12], argv[13]);
}

value camlidl_blop_c_my_sormqr(
	value _v_side,
	value _v_trans,
	value _v_m,
	value _v_n,
	value _v_k,
	value _v_a,
	value _v_dispa,
	value _v_lda,
	value _v_tau,
	value _v_c,
	value _v_dispc,
	value _v_ldc,
	value _v_work,
	value _v_lwork)
{
  int side; /*in*/
  int trans; /*in*/
  int m; /*in*/
  int n; /*in*/
  int k; /*in*/
  float *a; /*in,out*/
  int dispa; /*in*/
  int lda; /*in*/
  float *tau; /*in,out*/
  float *c; /*in,out*/
  int dispc; /*in*/
  int ldc; /*in*/
  float *work; /*in,out*/
  int lwork; /*in*/
  int _res;
  value _vres;

  side = Int_val(_v_side);
  trans = Int_val(_v_trans);
  m = Int_val(_v_m);
  n = Int_val(_v_n);
  k = Int_val(_v_k);
  a = Bigarray_val(_v_a)->data;
  dispa = Int_val(_v_dispa);
  lda = Int_val(_v_lda);
  tau = Bigarray_val(_v_tau)->data;
  c = Bigarray_val(_v_c)->data;
  dispc = Int_val(_v_dispc);
  ldc = Int_val(_v_ldc);
  work = Bigarray_val(_v_work)->data;
  lwork = Int_val(_v_lwork);
  _res = my_sormqr(side, trans, m, n, k, a, dispa, lda, tau, c, dispc, ldc, work, lwork);
  _vres = Val_int(_res);
  return _vres;
}

value camlidl_blop_c_my_sormqr_bytecode(value * argv, int argn)
{
  return camlidl_blop_c_my_sormqr(argv[0], argv[1], argv[2], argv[3], argv[4], argv[5], argv[6], argv[7], argv[8], argv[9], argv[10], argv[11], argv[12], argv[13]);
}

value camlidl_blop_c_my_zunmqr(
	value _v_side,
	value _v_trans,
	value _v_m,
	value _v_n,
	value _v_k,
	value _v_a,
	value _v_dispa,
	value _v_lda,
	value _v_tau,
	value _v_c,
	value _v_dispc,
	value _v_ldc,
	value _v_work,
	value _v_lwork)
{
  int side; /*in*/
  int trans; /*in*/
  int m; /*in*/
  int n; /*in*/
  int k; /*in*/
  complex *a; /*in,out*/
  int dispa; /*in*/
  int lda; /*in*/
  complex *tau; /*in,out*/
  complex *c; /*in,out*/
  int dispc; /*in*/
  int ldc; /*in*/
  complex *work; /*in,out*/
  int lwork; /*in*/
  int _res;
  value _vres;

  side = Int_val(_v_side);
  trans = Int_val(_v_trans);
  m = Int_val(_v_m);
  n = Int_val(_v_n);
  k = Int_val(_v_k);
  a = Bigarray_val(_v_a)->data;
  dispa = Int_val(_v_dispa);
  lda = Int_val(_v_lda);
  tau = Bigarray_val(_v_tau)->data;
  c = Bigarray_val(_v_c)->data;
  dispc = Int_val(_v_dispc);
  ldc = Int_val(_v_ldc);
  work = Bigarray_val(_v_work)->data;
  lwork = Int_val(_v_lwork);
  _res = my_zunmqr(side, trans, m, n, k, a, dispa, lda, tau, c, dispc, ldc, work, lwork);
  _vres = Val_int(_res);
  return _vres;
}

value camlidl_blop_c_my_zunmqr_bytecode(value * argv, int argn)
{
  return camlidl_blop_c_my_zunmqr(argv[0], argv[1], argv[2], argv[3], argv[4], argv[5], argv[6], argv[7], argv[8], argv[9], argv[10], argv[11], argv[12], argv[13]);
}

value camlidl_blop_c_my_cunmqr(
	value _v_side,
	value _v_trans,
	value _v_m,
	value _v_n,
	value _v_k,
	value _v_a,
	value _v_dispa,
	value _v_lda,
	value _v_tau,
	value _v_c,
	value _v_dispc,
	value _v_ldc,
	value _v_work,
	value _v_lwork)
{
  int side; /*in*/
  int trans; /*in*/
  int m; /*in*/
  int n; /*in*/
  int k; /*in*/
  scomplex *a; /*in,out*/
  int dispa; /*in*/
  int lda; /*in*/
  scomplex *tau; /*in,out*/
  scomplex *c; /*in,out*/
  int dispc; /*in*/
  int ldc; /*in*/
  scomplex *work; /*in,out*/
  int lwork; /*in*/
  int _res;
  value _vres;

  side = Int_val(_v_side);
  trans = Int_val(_v_trans);
  m = Int_val(_v_m);
  n = Int_val(_v_n);
  k = Int_val(_v_k);
  a = Bigarray_val(_v_a)->data;
  dispa = Int_val(_v_dispa);
  lda = Int_val(_v_lda);
  tau = Bigarray_val(_v_tau)->data;
  c = Bigarray_val(_v_c)->data;
  dispc = Int_val(_v_dispc);
  ldc = Int_val(_v_ldc);
  work = Bigarray_val(_v_work)->data;
  lwork = Int_val(_v_lwork);
  _res = my_cunmqr(side, trans, m, n, k, a, dispa, lda, tau, c, dispc, ldc, work, lwork);
  _vres = Val_int(_res);
  return _vres;
}

value camlidl_blop_c_my_cunmqr_bytecode(value * argv, int argn)
{
  return camlidl_blop_c_my_cunmqr(argv[0], argv[1], argv[2], argv[3], argv[4], argv[5], argv[6], argv[7], argv[8], argv[9], argv[10], argv[11], argv[12], argv[13]);
}


value camlidl_blop_c_my_dgerqf(
	value _v_m,
	value _v_n,
	value _v_a,
	value _v_dispa,
	value _v_lda,
	value _v_tau,
	value _v_work,
	value _v_lwork)
{
  int m; /*in*/
  int n; /*in*/
  double *a; /*in,out*/
  int dispa; /*in*/
  int lda; /*in*/
  double *tau; /*in,out*/
  double *work; /*in,out*/
  int lwork; /*in*/
  int _res;
  value _vres;

  m = Int_val(_v_m);
  n = Int_val(_v_n);
  a = Bigarray_val(_v_a)->data;
  dispa = Int_val(_v_dispa);
  lda = Int_val(_v_lda);
  tau = Bigarray_val(_v_tau)->data;
  work = Bigarray_val(_v_work)->data;
  lwork = Int_val(_v_lwork);
  _res = my_dgerqf(m, n, a, dispa, lda, tau, work, lwork);
  _vres = Val_int(_res);
  return _vres;
}

value camlidl_blop_c_my_dgerqf_bytecode(value * argv, int argn)
{
  return camlidl_blop_c_my_dgerqf(argv[0], argv[1], argv[2], argv[3], argv[4], argv[5], argv[6], argv[7]);
}

value camlidl_blop_c_my_sgerqf(
	value _v_m,
	value _v_n,
	value _v_a,
	value _v_dispa,
	value _v_lda,
	value _v_tau,
	value _v_work,
	value _v_lwork)
{
  int m; /*in*/
  int n; /*in*/
  float *a; /*in,out*/
  int dispa; /*in*/
  int lda; /*in*/
  float *tau; /*in,out*/
  float *work; /*in,out*/
  int lwork; /*in*/
  int _res;
  value _vres;

  m = Int_val(_v_m);
  n = Int_val(_v_n);
  a = Bigarray_val(_v_a)->data;
  dispa = Int_val(_v_dispa);
  lda = Int_val(_v_lda);
  tau = Bigarray_val(_v_tau)->data;
  work = Bigarray_val(_v_work)->data;
  lwork = Int_val(_v_lwork);
  _res = my_sgerqf(m, n, a, dispa, lda, tau, work, lwork);
  _vres = Val_int(_res);
  return _vres;
}

value camlidl_blop_c_my_sgerqf_bytecode(value * argv, int argn)
{
  return camlidl_blop_c_my_sgerqf(argv[0], argv[1], argv[2], argv[3], argv[4], argv[5], argv[6], argv[7]);
}

value camlidl_blop_c_my_dormrq(
	value _v_side,
	value _v_trans,
	value _v_m,
	value _v_n,
	value _v_k,
	value _v_a,
	value _v_dispa,
	value _v_lda,
	value _v_tau,
	value _v_c,
	value _v_dispc,
	value _v_ldc,
	value _v_work,
	value _v_lwork)
{
  int side; /*in*/
  int trans; /*in*/
  int m; /*in*/
  int n; /*in*/
  int k; /*in*/
  double *a; /*in,out*/
  int dispa; /*in*/
  int lda; /*in*/
  double *tau; /*in,out*/
  double *c; /*in,out*/
  int dispc; /*in*/
  int ldc; /*in*/
  double *work; /*in,out*/
  int lwork; /*in*/
  int _res;
  value _vres;

  side = Int_val(_v_side);
  trans = Int_val(_v_trans);
  m = Int_val(_v_m);
  n = Int_val(_v_n);
  k = Int_val(_v_k);
  a = Bigarray_val(_v_a)->data;
  dispa = Int_val(_v_dispa);
  lda = Int_val(_v_lda);
  tau = Bigarray_val(_v_tau)->data;
  c = Bigarray_val(_v_c)->data;
  dispc = Int_val(_v_dispc);
  ldc = Int_val(_v_ldc);
  work = Bigarray_val(_v_work)->data;
  lwork = Int_val(_v_lwork);
  _res = my_dormrq(side, trans, m, n, k, a, dispa, lda, tau, c, dispc, ldc, work, lwork);
  _vres = Val_int(_res);
  return _vres;
}

value camlidl_blop_c_my_dormrq_bytecode(value * argv, int argn)
{
  return camlidl_blop_c_my_dormrq(argv[0], argv[1], argv[2], argv[3], argv[4], argv[5], argv[6], argv[7], argv[8], argv[9], argv[10], argv[11], argv[12], argv[13]);
}

value camlidl_blop_c_my_sormrq(
	value _v_side,
	value _v_trans,
	value _v_m,
	value _v_n,
	value _v_k,
	value _v_a,
	value _v_dispa,
	value _v_lda,
	value _v_tau,
	value _v_c,
	value _v_dispc,
	value _v_ldc,
	value _v_work,
	value _v_lwork)
{
  int side; /*in*/
  int trans; /*in*/
  int m; /*in*/
  int n; /*in*/
  int k; /*in*/
  float *a; /*in,out*/
  int dispa; /*in*/
  int lda; /*in*/
  float *tau; /*in,out*/
  float *c; /*in,out*/
  int dispc; /*in*/
  int ldc; /*in*/
  float *work; /*in,out*/
  int lwork; /*in*/
  int _res;
  value _vres;

  side = Int_val(_v_side);
  trans = Int_val(_v_trans);
  m = Int_val(_v_m);
  n = Int_val(_v_n);
  k = Int_val(_v_k);
  a = Bigarray_val(_v_a)->data;
  dispa = Int_val(_v_dispa);
  lda = Int_val(_v_lda);
  tau = Bigarray_val(_v_tau)->data;
  c = Bigarray_val(_v_c)->data;
  dispc = Int_val(_v_dispc);
  ldc = Int_val(_v_ldc);
  work = Bigarray_val(_v_work)->data;
  lwork = Int_val(_v_lwork);
  _res = my_sormrq(side, trans, m, n, k, a, dispa, lda, tau, c, dispc, ldc, work, lwork);
  _vres = Val_int(_res);
  return _vres;
}

value camlidl_blop_c_my_sormrq_bytecode(value * argv, int argn)
{
  return camlidl_blop_c_my_sormrq(argv[0], argv[1], argv[2], argv[3], argv[4], argv[5], argv[6], argv[7], argv[8], argv[9], argv[10], argv[11], argv[12], argv[13]);
}


value camlidl_blop_c_my_zgerqf(
	value _v_m,
	value _v_n,
	value _v_a,
	value _v_dispa,
	value _v_lda,
	value _v_tau,
	value _v_work,
	value _v_lwork)
{
  int m; /*in*/
  int n; /*in*/
  complex *a; /*in,out*/
  int dispa; /*in*/
  int lda; /*in*/
  complex *tau; /*in,out*/
  complex *work; /*in,out*/
  int lwork; /*in*/
  int _res;
  value _vres;

  m = Int_val(_v_m);
  n = Int_val(_v_n);
  a = Bigarray_val(_v_a)->data;
  dispa = Int_val(_v_dispa);
  lda = Int_val(_v_lda);
  tau = Bigarray_val(_v_tau)->data;
  work = Bigarray_val(_v_work)->data;
  lwork = Int_val(_v_lwork);
  _res = my_zgerqf(m, n, a, dispa, lda, tau, work, lwork);
  _vres = Val_int(_res);
  return _vres;
}

value camlidl_blop_c_my_zgerqf_bytecode(value * argv, int argn)
{
  return camlidl_blop_c_my_zgerqf(argv[0], argv[1], argv[2], argv[3], argv[4], argv[5], argv[6], argv[7]);
}

value camlidl_blop_c_my_cgerqf(
	value _v_m,
	value _v_n,
	value _v_a,
	value _v_dispa,
	value _v_lda,
	value _v_tau,
	value _v_work,
	value _v_lwork)
{
  int m; /*in*/
  int n; /*in*/
  scomplex *a; /*in,out*/
  int dispa; /*in*/
  int lda; /*in*/
  scomplex *tau; /*in,out*/
  scomplex *work; /*in,out*/
  int lwork; /*in*/
  int _res;
  value _vres;

  m = Int_val(_v_m);
  n = Int_val(_v_n);
  a = Bigarray_val(_v_a)->data;
  dispa = Int_val(_v_dispa);
  lda = Int_val(_v_lda);
  tau = Bigarray_val(_v_tau)->data;
  work = Bigarray_val(_v_work)->data;
  lwork = Int_val(_v_lwork);
  _res = my_cgerqf(m, n, a, dispa, lda, tau, work, lwork);
  _vres = Val_int(_res);
  return _vres;
}

value camlidl_blop_c_my_cgerqf_bytecode(value * argv, int argn)
{
  return camlidl_blop_c_my_cgerqf(argv[0], argv[1], argv[2], argv[3], argv[4], argv[5], argv[6], argv[7]);
}


value camlidl_blop_c_my_zunmrq(
	value _v_side,
	value _v_trans,
	value _v_m,
	value _v_n,
	value _v_k,
	value _v_a,
	value _v_dispa,
	value _v_lda,
	value _v_tau,
	value _v_c,
	value _v_dispc,
	value _v_ldc,
	value _v_work,
	value _v_lwork)
{
  int side; /*in*/
  int trans; /*in*/
  int m; /*in*/
  int n; /*in*/
  int k; /*in*/
  complex *a; /*in,out*/
  int dispa; /*in*/
  int lda; /*in*/
  complex *tau; /*in,out*/
  complex *c; /*in,out*/
  int dispc; /*in*/
  int ldc; /*in*/
  complex *work; /*in,out*/
  int lwork; /*in*/
  int _res;
  value _vres;

  side = Int_val(_v_side);
  trans = Int_val(_v_trans);
  m = Int_val(_v_m);
  n = Int_val(_v_n);
  k = Int_val(_v_k);
  a = Bigarray_val(_v_a)->data;
  dispa = Int_val(_v_dispa);
  lda = Int_val(_v_lda);
  tau = Bigarray_val(_v_tau)->data;
  c = Bigarray_val(_v_c)->data;
  dispc = Int_val(_v_dispc);
  ldc = Int_val(_v_ldc);
  work = Bigarray_val(_v_work)->data;
  lwork = Int_val(_v_lwork);
  _res = my_zunmrq(side, trans, m, n, k, a, dispa, lda, tau, c, dispc, ldc, work, lwork);
  _vres = Val_int(_res);
  return _vres;
}

value camlidl_blop_c_my_zunmrq_bytecode(value * argv, int argn)
{
  return camlidl_blop_c_my_zunmrq(argv[0], argv[1], argv[2], argv[3], argv[4], argv[5], argv[6], argv[7], argv[8], argv[9], argv[10], argv[11], argv[12], argv[13]);
}

value camlidl_blop_c_my_cunmrq(
	value _v_side,
	value _v_trans,
	value _v_m,
	value _v_n,
	value _v_k,
	value _v_a,
	value _v_dispa,
	value _v_lda,
	value _v_tau,
	value _v_c,
	value _v_dispc,
	value _v_ldc,
	value _v_work,
	value _v_lwork)
{
  int side; /*in*/
  int trans; /*in*/
  int m; /*in*/
  int n; /*in*/
  int k; /*in*/
  scomplex *a; /*in,out*/
  int dispa; /*in*/
  int lda; /*in*/
  scomplex *tau; /*in,out*/
  scomplex *c; /*in,out*/
  int dispc; /*in*/
  int ldc; /*in*/
  scomplex *work; /*in,out*/
  int lwork; /*in*/
  int _res;
  value _vres;

  side = Int_val(_v_side);
  trans = Int_val(_v_trans);
  m = Int_val(_v_m);
  n = Int_val(_v_n);
  k = Int_val(_v_k);
  a = Bigarray_val(_v_a)->data;
  dispa = Int_val(_v_dispa);
  lda = Int_val(_v_lda);
  tau = Bigarray_val(_v_tau)->data;
  c = Bigarray_val(_v_c)->data;
  dispc = Int_val(_v_dispc);
  ldc = Int_val(_v_ldc);
  work = Bigarray_val(_v_work)->data;
  lwork = Int_val(_v_lwork);
  _res = my_cunmrq(side, trans, m, n, k, a, dispa, lda, tau, c, dispc, ldc, work, lwork);
  _vres = Val_int(_res);
  return _vres;
}

value camlidl_blop_c_my_cunmrq_bytecode(value * argv, int argn)
{
  return camlidl_blop_c_my_cunmrq(argv[0], argv[1], argv[2], argv[3], argv[4], argv[5], argv[6], argv[7], argv[8], argv[9], argv[10], argv[11], argv[12], argv[13]);
}


